(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, SpkTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
// This file defines the database schema.                                                                              // 17
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         // 19
// query it makes, so you can see if it's doing queries too often, etc.                                                // 20
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  var oldFind = Mongo.Collection.prototype.find;                                                                       // 22
                                                                                                                       //
  Mongo.Collection.prototype.find = function () {                                                                      // 23
    console.log(this._prefix, arguments);                                                                              // 24
    return oldFind.apply(this, arguments);                                                                             // 25
  };                                                                                                                   // 26
} // Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                    // 27
                                                                                                                       //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
} // TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                          // 34
                                                                                                                       //
                                                                                                                       //
var collectionOptions = {                                                                                              // 38
  defineMutationMethods: Meteor.isClient                                                                               // 38
}; // Set to `true` on the client so that method simulation works. Set to `false` on the server                        // 38
// so that we can be extra certain that all mutations must go through methods.                                         // 40
// Users = new Mongo.Collection("users");                                                                              // 42
// The users collection is special and can be accessed through `Meteor.users`.                                         // 43
// See https://docs.meteor.com/#/full/meteor_users.                                                                    // 44
//                                                                                                                     // 45
// There are two distinct types of entries in the users collection: identities and accounts. An                        // 46
// identity contains personal profile information and typically includes some intrinsic method for                     // 47
// authenticating as the owner of that information.                                                                    // 48
//                                                                                                                     // 49
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           // 50
// Each account can have multiple identities linked to it. To log in as an account you must first                      // 51
// authenticate as one of its linked identities.                                                                       // 52
//                                                                                                                     // 53
// Every user contains the following fields:                                                                           // 54
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         // 55
//        stable SHA-256 ID of this identity, hex-encoded.                                                             // 56
//   createdAt: Date when this entry was added to the collection.                                                      // 57
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                // 58
//   services: Object containing login data used by Meteor authentication services.                                    // 59
//   expires: Date when this user should be deleted. Only present for demo users.                                      // 60
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        // 61
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   // 62
//                     rather than as a Date object. We should fix that.                                               // 63
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     // 64
//              link. This field contains the app ID of the app that the user started out demoing.                     // 65
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      // 66
//              being a demo user.                                                                                     // 67
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       // 68
//              can be suspended. After some amount of time, the user will be completely deleted                       // 69
//              and removed from the DB.                                                                               // 70
//              It is an object with fields:                                                                           // 71
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        // 72
//                  chance to still login and reverse the suspension/deletion.                                         // 73
//                admin: The userId of the admin who suspended the account.                                            // 74
//                timestamp: Date object. When the suspension occurred.                                                // 75
//                willDelete: Boolean. If true, this account will be deleted after some time.                          // 76
//                                                                                                                     // 77
// Identity users additionally contain the following fields:                                                           // 78
//   profile: Object containing the data that will be shared with users and grains that come into                      // 79
//            contact with this identity. Includes the following fields:                                               // 80
//       service: String containing the name of this identity's authentication method.                                 // 81
//       name: String containing the chosen display name of the identity.                                              // 82
//       handle: String containing the identity's preferred handle.                                                    // 83
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          // 84
//                an identicon will be used.                                                                           // 85
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      // 86
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          // 87
//   referredBy: ID of the Account that referred this Identity.                                                        // 88
//                                                                                                                     // 89
// Account users additionally contain the following fields:                                                            // 90
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       // 91
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             // 92
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      // 93
//                       a separate array here so that we can use a Mongo index to enforce the                         // 94
//                       invariant that an identity only be a login identity for a single account.                     // 95
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   // 96
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        // 97
//                 to do this checking automatically.                                                                  // 98
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  // 99
//   signupKey: If this is an invited user, then this field contains their signup key.                                 // 100
//   signupNote: If the user was invited through a link, then this field contains the note that the                    // 101
//               inviter admin attached to the key.                                                                    // 102
//   signupEmail: If the user was invited by email, then this field contains the email address that                    // 103
//                the invite was sent to.                                                                              // 104
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    // 105
//                       terms of service.                                                                             // 106
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       // 107
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       // 108
//              module writes data here; we merely read it. Missing fields should be treated as                        // 109
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           // 110
//              TODO(cleanup): Use for referral bonus too.                                                             // 111
//   storageUsage: Number of bytes this user is currently storing.                                                     // 112
//   payments: Object defined by payments module, if loaded.                                                           // 113
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 // 114
//   accessRequests: Object containing the following fields; used to limit spam.                                       // 115
//       count: Number of "request access" emails during sent during the current interval.                             // 116
//       resetOn: Date when the count should be reset.                                                                 // 117
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              // 118
//                        stop writing new referredBy values onto Identities for this account.                         // 119
//   referredCompleteDate: The Date at which the completed referral occurred.                                          // 120
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        // 121
//                        reliably determining which Identity's names are safe to display.                             // 122
//   experiments: Object where each field is an experiment that the user is in, and each value                         // 123
//           is the parameters for that experiment. Typically, the value simply names which                            // 124
//           experiment group which the user is in, where "control" is one group. If an experiment                     // 125
//           is not listed, then the user should not be considered at all for the purpose of that                      // 126
//           experiment. Each experiment may define a point in time where users not already in the                     // 127
//           experiment may be added to it and assigned to a group (for example, at user creation                      // 128
//           time). Current experiments:                                                                               // 129
//       firstTimeBillingPrompt: OBSOLETE                                                                              // 130
//       freeGrainLimit: Value is "control" or or a number indicating the grain limit that the                         // 131
//               user should receive when on the "free" plan, e.g. "Infinity".                                         // 132
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       // 133
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              // 134
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", {                                                            // 136
  sparse: 1                                                                                                            // 136
});                                                                                                                    // 136
Meteor.users.ensureIndexOnServer("services.github.emails.email", {                                                     // 137
  sparse: 1                                                                                                            // 137
});                                                                                                                    // 137
Meteor.users.ensureIndexOnServer("services.email.email", {                                                             // 138
  unique: 1,                                                                                                           // 138
  sparse: 1                                                                                                            // 138
});                                                                                                                    // 138
Meteor.users.ensureIndexOnServer("loginIdentities.id", {                                                               // 139
  unique: 1,                                                                                                           // 139
  sparse: 1                                                                                                            // 139
});                                                                                                                    // 139
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", {                                                            // 140
  sparse: 1                                                                                                            // 140
});                                                                                                                    // 140
Meteor.users.ensureIndexOnServer("services.google.id", {                                                               // 141
  unique: 1,                                                                                                           // 141
  sparse: 1                                                                                                            // 141
});                                                                                                                    // 141
Meteor.users.ensureIndexOnServer("services.github.id", {                                                               // 142
  unique: 1,                                                                                                           // 142
  sparse: 1                                                                                                            // 142
});                                                                                                                    // 142
Meteor.users.ensureIndexOnServer("suspended.willDelete", {                                                             // 143
  sparse: 1                                                                                                            // 143
}); // TODO(cleanup): This index is obsolete; delete it.                                                               // 143
                                                                                                                       //
Meteor.users.ensureIndexOnServer("identities.id", {                                                                    // 146
  unique: 1,                                                                                                           // 146
  sparse: 1                                                                                                            // 146
});                                                                                                                    // 146
Packages = new Mongo.Collection("packages", collectionOptions); // Packages which are installed or downloading.        // 148
//                                                                                                                     // 150
// Each contains:                                                                                                      // 151
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    // 152
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   // 153
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                // 154
//       >1 = download byte count.                                                                                     // 155
//   error:  If status is "failed", error message string.                                                              // 156
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          // 157
//   appId:  If status is "ready", the application ID string.  Packages representing different                         // 158
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         // 159
//       and can cryptographically verify that a package belongs to a particular app ID.                               // 160
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        // 161
//       collector should at some point check whether there are any other references and, if not,                      // 162
//       delete the package.                                                                                           // 163
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         // 164
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    // 165
//     even if it has no users.                                                                                        // 166
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           // 167
//     packager.                                                                                                       // 168
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions); // List of packages currently made available via the dev tools running on the local machine.
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     // 172
// on the local machine to publish an under-development app to this server. That should only ever                      // 173
// happen on developers' desktop machines.                                                                             // 174
//                                                                                                                     // 175
// While a dev package is published, it automatically appears as installed by every user of the                        // 176
// server, and it overrides all packages with the same application ID. If any instances of those                       // 177
// packages are currently open, they are killed and reset on publish.                                                  // 178
//                                                                                                                     // 179
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     // 180
// are again killed and refreshed.                                                                                     // 181
//                                                                                                                     // 182
// Each contains:                                                                                                      // 183
//   _id:  The package ID string (as with Packages._id).                                                               // 184
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  // 185
//   timestamp:  Time when the package was last updated. If this changes while the package is                          // 186
//     published, all running instances are reset. This is used e.g. to reset the app each time                        // 187
//     changes are made to the source code.                                                                            // 188
//   manifest:  The app's manifest, as with Packages.manifest.                                                         // 189
//   mountProc: True if the supervisor should mount /proc.                                                             // 190
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions); // List of actions that each user has installed which create new grains.  Each app may install
// some number of actions (usually, one).                                                                              // 194
//                                                                                                                     // 195
// Each contains:                                                                                                      // 196
//   _id:  random                                                                                                      // 197
//   userId:  Account ID of the user who has installed this action.                                                    // 198
//   packageId:  Package used to run this action.                                                                      // 199
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 200
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 // 201
//       that clients can access it without subscribing to the Packages collection.                                    // 202
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 203
//       searchability.                                                                                                // 204
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               // 205
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     // 206
//       `{defaultText: "New Spreadsheet"}`.                                                                           // 207
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        // 208
//   command:  Manifest.Command to run this action (see package.capnp).                                                // 209
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions); // Grains belonging to users.                              // 211
//                                                                                                                     // 213
// Each contains:                                                                                                      // 214
//   _id:  random                                                                                                      // 215
//   packageId:  _id of the package of which this grain is an instance.                                                // 216
//   packageSalt: If present, a random string that will used in session ID generation. This field                      // 217
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            // 218
//       clients with active sessions.                                                                                 // 219
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 220
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 221
//       searchability.                                                                                                // 222
//   userId: The _id of the account that owns this grain.                                                              // 223
//   identityId: The identity with which the owning account prefers to open this grain.                                // 224
//   title:  Human-readable string title, as chosen by the user.                                                       // 225
//   lastUsed:  Date when the grain was last used by a user.                                                           // 226
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    // 227
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    // 228
//                   time a session to this grain was opened.                                                          // 229
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       // 230
//            this date, the grain will be automatically deleted.                                                      // 231
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        // 232
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    // 233
//              of querying.                                                                                           // 234
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        // 235
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        // 236
//   size: On-disk size of the grain in bytes.                                                                         // 237
//                                                                                                                     // 238
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     // 239
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      // 240
// is implemented.                                                                                                     // 241
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     // 242
//       web publishing. This field is initialized when first requested by the app.                                    // 243
                                                                                                                       //
Grains.ensureIndexOnServer("cachedViewInfo.matchRequests.tags.id", {                                                   // 245
  sparse: 1                                                                                                            // 245
});                                                                                                                    // 245
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions); // *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             // 249
// collection.                                                                                                         // 250
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions); // Edges in the social graph.                          // 252
//                                                                                                                     // 254
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         // 255
// will show up in her user-picker UI for actions like share-by-identity.                                              // 256
//                                                                                                                     // 257
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        // 258
// Bob's.                                                                                                              // 259
//                                                                                                                     // 260
// Each contains:                                                                                                      // 261
//   _id: random                                                                                                       // 262
//   ownerId: The accountId of the user account who owns this contact.                                                 // 263
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        // 264
//            the contact to the owner.                                                                                // 265
//   created: Date when this contact was created.                                                                      // 266
//   identityId: The `_id` of the user whose contact info this contains.                                               // 267
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions); // UI sessions open to particular grains.  A new session is created each time a user opens a grain.
//                                                                                                                     // 271
// Each contains:                                                                                                      // 272
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     // 273
//       client, and the grain's `packageSalt`.                                                                        // 274
//   grainId:  _id of the grain to which this session is connected.                                                    // 275
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     // 276
//       '*' in WILDCARD_HOST.                                                                                         // 277
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         // 278
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      // 279
//       have the same `tabId` as the outer session.                                                                   // 280
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        // 281
//       period.                                                                                                       // 282
//   userId:  Account ID of the user who owns this session.                                                            // 283
//   identityId:  Identity ID of the user who owns this session.                                                       // 284
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      // 285
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         // 286
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     // 287
//       are present.                                                                                                  // 288
//   powerboxView: Information about a server-initiated powerbox interaction taking place in this                      // 289
//       session. When the client sees a `powerboxView` appear on the session, it opens the                            // 290
//       powerbox popup according to the contents. This field is an object containing one of:                          // 291
//     offer: A capability is being offered to the user by the app. This is an object containing:                      // 292
//       token: For a non-UiView capability, the API token that can be used to restore this                            // 293
//           capability.                                                                                               // 294
//       uiView: A UiView capability. This object contains one of:                                                     // 295
//         tokenId: The _id of an ApiToken belonging to the current user.                                              // 296
//         token: A full webkey token which can be opened by an anonymous user.                                        // 297
//     fulfill: A capability is being offered which fulfills the active powerbox request. This                         // 298
//         is an object with members:                                                                                  // 299
//       token: The SturdyRef of the fulfilling capability. This token can only be used in a call                      // 300
//           to claimRequest() by the requesting                                                                       // 301
//           grain.                                                                                                    // 302
//       descriptor: Packed-base64 PowerboxDescriptor for the capability.                                              // 303
//   powerboxRequest: If present, this session is a powerbox request session. Object containing:                       // 304
//     descriptors: Array of PowerboxDescriptors representing the request.                                             // 305
//     requestingSession: Session ID of the session initiating the request.                                            // 306
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     // 307
//       until newSession is called on the UiView.                                                                     // 308
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        // 309
//       until newSession is called on the UiView.                                                                     // 310
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   // 311
//       request                                                                                                       // 312
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions); // Invite keys which may be used by users to get access to Sandstorm.
//                                                                                                                     // 316
// Each contains:                                                                                                      // 317
//   _id:  random                                                                                                      // 318
//   used:  Boolean indicating whether this key has already been consumed.                                             // 319
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          // 320
//   email: If this key was sent as an email invite, the email address to which it was sent.                           // 321
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions); // Contains usage statistics taken on a regular interval. Each entry is a data point.
//                                                                                                                     // 325
// Each contains:                                                                                                      // 326
//   timestamp: Date when measurements were taken.                                                                     // 327
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   // 328
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           // 329
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           // 330
//                                                                                                                     // 331
// Each of daily, weekly, and monthly contains:                                                                        // 332
//   activeUsers: The number of unique users who have used a grain on the server in the time                           // 333
//       interval. Only counts logged-in users.                                                                        // 334
//   demoUsers: Demo users.                                                                                            // 335
//   appDemoUsers: Users that came in through "app demo".                                                              // 336
//   activeGrains: The number of unique grains that have been used in the time interval.                               // 337
//   apps: An object indexed by app ID recording, for each app:                                                        // 338
//       owners: Number of unique owners of this app (counting only grains that still exist).                          // 339
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    // 340
//         only grains that still exist).                                                                              // 341
//       grains: Number of active grains of this app (that still exist).                                               // 342
//       deleted: Number of non-demo grains of this app that were deleted.                                             // 343
//       demoed: Number of demo grains created and expired.                                                            // 344
//       appDemoUsers: Number of app demos initiated with this app.                                                    // 345
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions); // Contains records of objects that were deleted, for stat-keeping purposes.
//                                                                                                                     // 349
// Each contains:                                                                                                      // 350
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             // 351
//   lastActive: Date of the user's or grain's last activity.                                                          // 352
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     // 353
//     arrived to demo. For others, undefined.                                                                         // 354
//   experiments: The experiments the user (or owner of the grain) was in. See user.experiments.                       // 355
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions); // Tokens corresponding to backup files that are currently stored on the server. A user receives
// a token when they create a backup file (either by uploading it, or by backing up one of their                       // 359
// grains) and may use the token to read the file (either to download it, or to restore a new                          // 360
// grain from it).                                                                                                     // 361
//                                                                                                                     // 362
// Each contains:                                                                                                      // 363
//   _id:       The unguessable token string.                                                                          // 364
//   name:      Suggested filename.                                                                                    // 365
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        // 366
                                                                                                                       //
SpkTokens = new Mongo.Collection("spkTokens", collectionOptions); // A lot like FileTokens, but for SPK uploads.       // 368
//                                                                                                                     // 370
// Each contains:                                                                                                      // 371
//   _id:       The unguessable token string.                                                                          // 372
//   timestamp: Creation time. Used to figure out when the token should be wiped.                                      // 373
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions); // Access tokens for APIs exported by apps.          // 375
//                                                                                                                     // 377
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      // 378
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      // 379
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           // 380
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         // 381
// `MainView`) -- the fields of type `Data` are API tokens.                                                            // 382
//                                                                                                                     // 383
// Each contains:                                                                                                      // 384
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           // 385
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      // 386
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       // 387
//              That is, the UiView's newSession() method will intersect the requested permissions                     // 388
//              with this identity's permissions before forwarding on to the underlying app. If                        // 389
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     // 390
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        // 391
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     // 392
//              this is NOT the identity against which the `requiredPermissions` parameter of                          // 393
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   // 394
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    // 395
//              that created the token.                                                                                // 396
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         // 397
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    // 398
//              permissions will be intersected with those held by `identityId` when the view is                       // 399
//              opened.                                                                                                // 400
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    // 401
//              anonymous rather than as directly associated with `identityId`. This has no effect                     // 402
//              on the permissions granted.                                                                            // 403
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      // 404
//              the app or its supervisor (whereas without this it strictly represents UiView).                        // 405
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      // 406
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             // 407
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               // 408
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    // 409
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    // 410
//              containing exactly one of the following fields:                                                        // 411
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    // 412
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           // 413
//                           `Notifications` collection.                                                               // 414
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      // 415
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      // 416
//                  database when that happens. This field contains the boolean true to signify that                   // 417
//                  it has been set.                                                                                   // 418
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     // 419
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           // 420
//                      value is an object containing the fields `id` and `services`. `id` is the                      // 421
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             // 422
//                      powerbox query for matching verified emails. `services` is a                                   // 423
//                      list of names of identity providers that are trusted to verify addresses.                      // 424
//                      If `services` is omitted or falsy, all configured identity providers are                       // 425
//                      trusted. Note that a malicious user could specify invalid names in the                         // 426
//                      list; they should be ignored.                                                                  // 427
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               // 428
//                      An object containing `verifierId`, `tabId`, and `address`.                                     // 429
//       identity: An Identity capability. The field is the identity ID.                                               // 430
//       http: An ApiSession capability pointing to an external HTTP service. Object containing:                       // 431
//           url: Base URL of the external service.                                                                    // 432
//           auth: Authentication mechanism. Object containing one of:                                                 // 433
//               none: Value "null". Indicates no authorization.                                                       // 434
//               bearer: A bearer token to pass in the `Authorization: Bearer` header on all                           // 435
//                   requests. Encrypted with nonce 0.                                                                 // 436
//               basic: A `{username, password}` object. The password is encrypted with nonce 0.                       // 437
//                   Before encryption, the password is padded to 32 bytes by appending NUL bytes,                     // 438
//                   in order to mask the length of small passwords.                                                   // 439
//               refresh: An OAuth refresh token, which can be exchanged for an access token.                          // 440
//                   Encrypted with nonce 0.                                                                           // 441
//               TODO(security): How do we protect URLs that directly embed their secret? We don't                     // 442
//                   want to encrypt the full URL since this would make it hard to show a                              // 443
//                   meaningful audit UI, but maybe we could figure out a way to extract the key                       // 444
//                   part and encrypt it separately?                                                                   // 445
//   parentToken: If present, then this token represents exactly the capability represented by                         // 446
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    // 447
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       // 448
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       // 449
//              is set to the identity that shared the view, and `accountId` is set to the account                     // 450
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             // 451
//              `parentToken` is present.                                                                              // 452
//   parentTokenKey: The actual parent token -- whereas `parentToken` is only the parent token ID                      // 453
//              (hash). `parentTokenFull` is encrypted with nonce 0 (see below). This is needed                        // 454
//              in particular when the parent contains encrypted fields, since those would need to                     // 455
//              be decrypted using this key. If the parent contains no encrypted fields then                           // 456
//              `parentTokenKey` may be omitted from the child.                                                        // 457
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          // 458
//              revocation. This should be displayed when visualizing incoming capabilities to                         // 459
//              the grain identified by `grainId`.                                                                     // 460
//   created:   Date when this token was created.                                                                      // 461
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    // 462
//              become un-revoked in the future.                                                                       // 463
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     // 464
//              this date, the token will be automatically deleted.                                                    // 465
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        // 466
//              so treat this token the same as "trashed". It is denormalized out of Users for                         // 467
//              ease of querying.                                                                                      // 468
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     // 469
//   lastUsed:  Optional Date when this token was last used.                                                           // 470
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             // 471
//              as passed to the `save()` call that created this token. If not present, treat                          // 472
//              as `webkey` (the default for `ApiTokenOwner`).                                                         // 473
//   expiresIfUnused:                                                                                                  // 474
//              Optional Date after which the token, if it has not been used yet, expires.                             // 475
//              This field should be cleared on a token's first use.                                                   // 476
//   requirements: List of conditions which must hold for this token to be considered valid.                           // 477
//              Semantically, this list specifies the powers which were *used* to originally                           // 478
//              create the token. If any condition in the list becomes untrue, then the token must                     // 479
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         // 480
//              through it must also become revoked. Each item is the JSON serialization of the                        // 481
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         // 482
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          // 483
//              cleaned up when the token is.                                                                          // 484
//                                                                                                                     // 485
// It is important to note that a token's owner and provider are independent from each other. To                       // 486
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    // 487
//                                                                                                                     // 488
// struct ApiToken {                                                                                                   // 489
//   owner :ApiTokenOwner;                                                                                             // 490
//   provider :union {                                                                                                 // 491
//     grain :group {                                                                                                  // 492
//       grainId :Text;                                                                                                // 493
//       union {                                                                                                       // 494
//         uiView :group {                                                                                             // 495
//           identityId :Text;                                                                                         // 496
//           roleAssignment :RoleAssignment;                                                                           // 497
//           forSharing :Bool;                                                                                         // 498
//         }                                                                                                           // 499
//         objectId :SupervisorObjectId;                                                                               // 500
//       }                                                                                                             // 501
//     }                                                                                                               // 502
//     frontendRef :union {                                                                                            // 503
//       notificationHandle :Text;                                                                                     // 504
//       ipNetwork :Bool;                                                                                              // 505
//       ipInterface :Bool;                                                                                            // 506
//       emailVerifier :group {                                                                                        // 507
//         id :Text;                                                                                                   // 508
//         services :List(String);                                                                                     // 509
//       }                                                                                                             // 510
//       verifiedEmail :group {                                                                                        // 511
//         verifierId :Text;                                                                                           // 512
//         tabId :Text;                                                                                                // 513
//         address :Text;                                                                                              // 514
//       }                                                                                                             // 515
//       identity :Text;                                                                                               // 516
//       http :group {                                                                                                 // 517
//         url :Text;                                                                                                  // 518
//         auth :union {                                                                                               // 519
//           none :Void;                                                                                               // 520
//           bearer :Text;                                                                                             // 521
//           basic :group { username :Text; password :Text; }                                                          // 522
//           refresh :Text;                                                                                            // 523
//         }                                                                                                           // 524
//       }                                                                                                             // 525
//     }                                                                                                               // 526
//     child :group {                                                                                                  // 527
//       parentToken :Text;                                                                                            // 528
//       union {                                                                                                       // 529
//         uiView :group {                                                                                             // 530
//           grainId :Text;                                                                                            // 531
//           identityId :Text;                                                                                         // 532
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        // 533
//         }                                                                                                           // 534
//         other :Void;                                                                                                // 535
//       }                                                                                                             // 536
//     }                                                                                                               // 537
//   }                                                                                                                 // 538
//   requirements: List(Supervisor.MembraneRequirement);                                                               // 539
//   ...                                                                                                               // 540
// }                                                                                                                   // 541
//                                                                                                                     // 542
// ENCRYPTION                                                                                                          // 543
//                                                                                                                     // 544
// We want to make sure that someone who obtains a copy of the database cannot use it to gain live                     // 545
// credentials.                                                                                                        // 546
//                                                                                                                     // 547
// The actual token corresponding to an ApiToken entry is not stored in the entry itself. Instead,                     // 548
// the ApiToken's `_id` is constructed as a SHA256 hash of the actual token. To use an ApiToken                        // 549
// in the live system, you must present the original token.                                                            // 550
//                                                                                                                     // 551
// Additionally, some ApiToken entries contain tokens to third-party services, e.g. OAuth tokens                       // 552
// or even passwords. Such tokens are encrypted, using the ApiToken entry's own full token (which,                     // 553
// again, is not stored in the database) as the encryption key.                                                        // 554
//                                                                                                                     // 555
// When such encryption is applied, the cipher used is ChaCha20. All API tokens are 256-bit base64                     // 556
// strings, hence can be used directly as the key. No MAC is applied, because this scheme is not                       // 557
// intended to protect against attackers who have write access to the database -- such an attacker                     // 558
// could almost certainly do more damage by modifying the non-encrypted fields anyway. (Put another                    // 559
// way, if we wanted to MAC something, we'd need to MAC the entire ApiToken structure, not just                        // 560
// the encrypted key. But we don't have a way to do that at present.)                                                  // 561
//                                                                                                                     // 562
// ChaCha20 requires a nonce. Luckily, all of the fields we wish to encrypt are immutable, so we                       // 563
// don't have to worry about tracking nonces over time -- we can just assign a static nonce to each                    // 564
// field. Moreover, many (currently, all) of these fields are mutually exclusive, so can even share                    // 565
// nonces. Currently, nonces map to fields as follows:                                                                 // 566
//                                                                                                                     // 567
// nonce 0:                                                                                                            // 568
//     parentTokenKey                                                                                                  // 569
//     frontendRef.http.auth.basic.password                                                                            // 570
//     frontendRef.http.auth.bearer                                                                                    // 571
//     frontendRef.http.auth.refresh                                                                                   // 572
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", {                                                                             // 574
  sparse: 1                                                                                                            // 574
});                                                                                                                    // 574
ApiTokens.ensureIndexOnServer("owner.user.identityId", {                                                               // 575
  sparse: 1                                                                                                            // 575
});                                                                                                                    // 575
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", {                                                        // 576
  sparse: 1                                                                                                            // 576
});                                                                                                                    // 576
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions); // Allows defining some limited static behavior for an API host when accessed unauthenticated. This
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      // 580
// to probe an API host without authentication to determine capabilities such as DAV protocols                         // 581
// supported, before authenticating to perform real requests. An app can specify these properties                      // 582
// when creating an offerTemplate.                                                                                     // 583
//                                                                                                                     // 584
// Each contains:                                                                                                      // 585
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             // 586
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     // 587
//                 up when ApiTokens are deleted.                                                                      // 588
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          // 589
//                 This is an object containing fields:                                                                // 590
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             // 591
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 // 592
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        // 593
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      // 594
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          // 595
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          // 596
//                 fields:                                                                                             // 597
//     type:       Content-Type.                                                                                       // 598
//     language:   Content-Language.                                                                                   // 599
//     encoding:   Content-Encoding.                                                                                   // 600
//     body:       Entity-body as a string or buffer.                                                                  // 601
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions); // Notifications for a user.                 // 603
//                                                                                                                     // 605
// Each contains:                                                                                                      // 606
//   _id:          random                                                                                              // 607
//   grainId:      The grain originating this notification, if any.                                                    // 608
//   userId:       Account ID of the user receiving the notification.                                                  // 609
//   text:         The JSON-ified LocalizedText to display in the notification.                                        // 610
//   isUnread:     Boolean indicating if this notification is unread.                                                  // 611
//   timestamp:    Date when this notification was last updated                                                        // 612
//   eventType:    If this notification is due to an activity event, this is the numeric index                         // 613
//                 of the event type on the grain's ViewInfo.                                                          // 614
//   count:        The number of times this exact event has repeated. Identical events are                             // 615
//                 aggregated by incrementing the count.                                                               // 616
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      // 617
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               // 618
//                 initiatingIdentity is present, the notification is not from a user.                                 // 619
//   path:         Path inside the grain to which the user should be directed if they click on                         // 620
//                 the notification.                                                                                   // 621
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             // 622
//                 ApiToken referencing the `OngoingNotification` capability.                                          // 623
//   admin:        If present, this is a notification intended for an admin.                                           // 624
//     action:     If present, this is a (string) link that the notification should direct the                         // 625
//                 admin to.                                                                                           // 626
//     type:       The type of notification -- currently can only be "reportStats".                                    // 627
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     // 628
//                 as keys.                                                                                            // 629
//     $appId:     The appId that has an outstanding update.                                                           // 630
//       packageId: The packageId that it will update to.                                                              // 631
//       name: The name of the app. (appTitle from package.manifest)                                                   // 632
//       version: The app's version number. (appVersion from package.manifest)                                         // 633
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           // 634
//   referral:     If this boolean field is true, then treat this notification as a referral                           // 635
//                 notification. This causes text to be ignored, since we need custom logic.                           // 636
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      // 637
//                 a one-time notification only to Oasis users who existed when the bonus program                      // 638
//                 was implemented.                                                                                    // 639
//   identityChanges: If this boolean field is true, this notification should show a warning about                     // 640
//                 upcoming changes to the identity model.                                                             // 641
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions); // Activity events to which a user is subscribed.
//                                                                                                                     // 645
// Each contains:                                                                                                      // 646
//   _id:          random                                                                                              // 647
//   identityId:   Who is subscribed.                                                                                  // 648
//   grainId:      Grain to which subscription applies.                                                                // 649
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       // 650
//                 whole grain.                                                                                        // 651
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         // 652
//                 This allows is useful to express:                                                                   // 653
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  // 654
//                 - The owner of a grain does not want notifications (normally, they are                              // 655
//                   implicitly subscribed).                                                                           // 656
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      // 657
//                   which they comment, so they mute the grain.                                                       // 658
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 660
ActivitySubscriptions.ensureIndexOnServer({                                                                            // 661
  "grainId": 1,                                                                                                        // 661
  "threadPath": 1                                                                                                      // 661
});                                                                                                                    // 661
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions); // Access tokens for the Stats collection        // 663
//                                                                                                                     // 665
// These tokens are used for accessing the ActivityStats collection remotely                                           // 666
// (ie. from a dashboard webapp)                                                                                       // 667
//                                                                                                                     // 668
// Each contains:                                                                                                      // 669
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  // 670
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions); // Miscellaneous configuration and other settings              // 672
//                                                                                                                     // 674
// This table is currently only used for persisting BASE_URL from one session to the next,                             // 675
// but in general any miscellaneous settings should go in here                                                         // 676
//                                                                                                                     // 677
// Each contains:                                                                                                      // 678
//   _id:       The name of the setting. eg. "BASE_URL"                                                                // 679
//   value:     The value of the setting.                                                                              // 680
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions); // Settings for this Sandstorm instance go here. They are configured through the adminSettings
// route. This collection differs from misc in that any admin user can update it through the admin                     // 684
// interface.                                                                                                          // 685
//                                                                                                                     // 686
// Each contains:                                                                                                      // 687
//   _id:       The name of the setting. eg. "smtpConfig"                                                              // 688
//   value:     The value of the setting.                                                                              // 689
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     // 690
//                       so, it will also write an object to this field indicating why the reset was                   // 691
//                       needed. That object can have the following variants:                                          // 692
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      // 693
//                           with the old BASE_URL.                                                                    // 694
//   preinstalledApps: A list of objects:                                                                              // 695
//     appId: The Packages.appId of the app to install                                                                 // 696
//     status: packageId                                                                                               // 697
//     packageId: The Packages._id of the app to install                                                               // 698
//                                                                                                                     // 699
//   potentially other fields that are unique to the setting                                                           // 700
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions); // This table tracks which migrations we have applied to this instance.
// It contains a single entry:                                                                                         // 704
//   _id:       "migrations_applied"                                                                                   // 705
//   value:     The number of migrations this instance has successfully completed.                                     // 706
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions); // Collection of static assets served up from the Sandstorm server's "static" host. We only
// support relatively small assets: under 1MB each.                                                                    // 710
//                                                                                                                     // 711
// Each contains:                                                                                                      // 712
//   _id:       Random ID; will be used in the URL.                                                                    // 713
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            // 714
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              // 715
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    // 716
//   content:   The asset content (byte buffer).                                                                       // 717
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    // 718
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        // 719
//       to catch leaked assets, although it's probably not a big deal in practice.                                    // 720
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions); // Collection of tokens representing a single-use permission to upload an asset, such as a new
// profile picture.                                                                                                    // 724
//                                                                                                                     // 725
// Each contains:                                                                                                      // 726
//   _id:       Random ID.                                                                                             // 727
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 // 728
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          // 729
//           userId: Account ID of user whose picture shall be replaced.                                               // 730
//           identityId: Which of the user's identities shall be updated.                                              // 731
//   expires:   Time when this token will go away if unused.                                                           // 732
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions); // Subscription plans, which determine quota.                // 734
//                                                                                                                     // 736
// Each contains:                                                                                                      // 737
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                // 738
//   storage: Number of bytes this user is allowed to store.                                                           // 739
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          // 740
//   computeLabel: Label to display to the user describing this plan's compute units.                                  // 741
//   grains: Total number of grains this user can create (often `Infinity`).                                           // 742
//   price: Price per month in US cents.                                                                               // 743
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           // 744
//       allowed to switch away.                                                                                       // 745
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      // 746
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions); // A mirror of the data from the App Market index      // 748
//                                                                                                                     // 750
// Each contains:                                                                                                      // 751
//   _id: the appId of the app                                                                                         // 752
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    // 753
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions); // Cache of Keybase profile information. The profile for a user is re-fetched every time a package
// by that user is installed, as well as if the keybase profile is requested and not already                           // 757
// present for some reason.                                                                                            // 758
//                                                                                                                     // 759
// Each contains:                                                                                                      // 760
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   // 761
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    // 762
//   handle: Keybase handle.                                                                                           // 763
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      // 764
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         // 765
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          // 766
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     // 767
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     // 768
//     server is currently actively checking this proof). Note that if a check fails due to network                    // 769
//     errors, the status goes back to "unverified".                                                                   // 770
//                                                                                                                     // 771
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          // 772
//       for now and we just trust Keybase.                                                                            // 773
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions); // OBSOLETE: This was used to implement the Sandstorm for Work paywall, which has been removed.
//   Collection object still defined because it could have old data in it, for servers that used                       // 777
//   to have a feature key.                                                                                            // 778
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions); // Responsible for storing information about setup sessions.  Contains a single document with three
// keys:                                                                                                               // 782
//                                                                                                                     // 783
//   _id: "current-session"                                                                                            // 784
//   creationDate: Date object indicating when this session was created.                                               // 785
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              // 786
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions); // Responsible for very short-lived queueing of desktop notification information.
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        // 790
// odd in that it is intended primarily for edge-triggered communications, but                                         // 791
// Meteor's collections aren't really designed to support that organization.                                           // 792
// Fields for each :                                                                                                   // 793
//                                                                                                                     // 794
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            // 795
//   creationDate: Date object. indicating when this notification was posted.                                          // 796
//   userId: String. Account id to which this notification was published.                                              // 797
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   // 798
//                            notification is activated.                                                               // 799
//   appActivity: Object with fields:                                                                                  // 800
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          // 801
//           present, it will have one of the following shapes:                                                        // 802
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      // 803
//       {                                                                                                             // 804
//         identityId: String  The user's identity ID.                                                                 // 805
//         name: String        The user's display name.                                                                // 806
//         avatarUrl: String   The URL for the user's profile picture.                                                 // 807
//       },                                                                                                            // 808
//     grainId: String,      Which grain this action took place on                                                     // 809
//     path: String,         The path of the notification.                                                             // 810
//     body: Util.LocalizedText,  The main body of the activity event.                                                 // 811
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 // 812
//                                     { defaultText: "added a comment" }                                              // 813
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions); // A standalone domain that points to a single share link. These domains act a little different
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     // 817
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         // 818
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    // 819
// login.                                                                                                              // 820
// Fields for each :                                                                                                   // 821
//                                                                                                                     // 822
//   _id: String. The domain name to use.                                                                              // 823
//   token: String. _id of a sharing token (it must be a webkey).                                                      // 824
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 826
  Meteor.publish("credentials", function () {                                                                          // 827
    // Data needed for isSignedUp() and isAdmin() to work.                                                             // 828
    if (this.userId) {                                                                                                 // 830
      var db = this.connection.sandstormDb;                                                                            // 831
      return [Meteor.users.find({                                                                                      // 832
        _id: this.userId                                                                                               // 833
      }, {                                                                                                             // 833
        fields: {                                                                                                      // 834
          signupKey: 1,                                                                                                // 834
          isAdmin: 1,                                                                                                  // 834
          expires: 1,                                                                                                  // 834
          storageUsage: 1,                                                                                             // 834
          plan: 1,                                                                                                     // 835
          planBonus: 1,                                                                                                // 835
          hasCompletedSignup: 1,                                                                                       // 835
          experiments: 1,                                                                                              // 835
          referredIdentityIds: 1,                                                                                      // 836
          cachedStorageQuota: 1,                                                                                       // 836
          suspended: 1                                                                                                 // 836
        }                                                                                                              // 834
      }), db.collections.plans.find()];                                                                                // 834
    } else {                                                                                                           // 839
      return [];                                                                                                       // 840
    }                                                                                                                  // 841
  });                                                                                                                  // 842
}                                                                                                                      // 843
                                                                                                                       //
var countReferrals = function (user) {                                                                                 // 845
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 846
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 847
};                                                                                                                     // 848
                                                                                                                       //
var calculateReferralBonus = function (user) {                                                                         // 850
  // This function returns an object of the form:                                                                      // 851
  //                                                                                                                   // 852
  // - {grains: 0, storage: 0}                                                                                         // 853
  //                                                                                                                   // 854
  // which are extra resources this account gets as part of participating in the referral                              // 855
  // program. (Storage is measured in bytes, as usual for plans.)                                                      // 856
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        // 858
  //   payments-specific) and aggregating into `planBonus`.                                                            // 859
  // Authorization note: Only call this if accountId is the current user!                                              // 861
  var isPaid = user.plan && user.plan !== "free";                                                                      // 862
  successfulReferralsCount = countReferrals(user);                                                                     // 864
                                                                                                                       //
  if (isPaid) {                                                                                                        // 865
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 866
    return {                                                                                                           // 867
      grains: 0,                                                                                                       // 867
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus)                                       // 868
    };                                                                                                                 // 867
  } else {                                                                                                             // 871
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 872
    var bonus = {                                                                                                      // 873
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 874
    };                                                                                                                 // 873
                                                                                                                       //
    if (successfulReferralsCount > 0) {                                                                                // 878
      bonus.grains = Infinity;                                                                                         // 879
    } else {                                                                                                           // 880
      bonus.grains = 0;                                                                                                // 881
    }                                                                                                                  // 882
                                                                                                                       //
    return bonus;                                                                                                      // 884
  }                                                                                                                    // 885
};                                                                                                                     // 886
                                                                                                                       //
isAdmin = function () {                                                                                                // 888
  // Returns true if the user is the administrator.                                                                    // 889
  var user = Meteor.user();                                                                                            // 891
                                                                                                                       //
  if (user && user.isAdmin) {                                                                                          // 892
    return true;                                                                                                       // 893
  } else {                                                                                                             // 894
    return false;                                                                                                      // 895
  }                                                                                                                    // 896
};                                                                                                                     // 897
                                                                                                                       //
isAdminById = function (id) {                                                                                          // 899
  // Returns true if the user's id is the administrator.                                                               // 900
  var user = Meteor.users.findOne({                                                                                    // 902
    _id: id                                                                                                            // 902
  }, {                                                                                                                 // 902
    fields: {                                                                                                          // 902
      isAdmin: 1                                                                                                       // 902
    }                                                                                                                  // 902
  });                                                                                                                  // 902
                                                                                                                       //
  if (user && user.isAdmin) {                                                                                          // 903
    return true;                                                                                                       // 904
  } else {                                                                                                             // 905
    return false;                                                                                                      // 906
  }                                                                                                                    // 907
};                                                                                                                     // 908
                                                                                                                       //
findAdminUserForToken = function (token) {                                                                             // 910
  if (!token.requirements) {                                                                                           // 911
    return;                                                                                                            // 912
  }                                                                                                                    // 913
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 915
    return "userIsAdmin" in requirement;                                                                               // 916
  });                                                                                                                  // 917
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 919
    return;                                                                                                            // 920
  }                                                                                                                    // 921
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 923
    return;                                                                                                            // 924
  }                                                                                                                    // 925
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 927
};                                                                                                                     // 928
                                                                                                                       //
var wildcardHost = Meteor.settings.public.wildcardHost.toLowerCase().split("*");                                       // 930
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 932
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 933
}                                                                                                                      // 934
                                                                                                                       //
matchWildcardHost = function (host) {                                                                                  // 936
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           // 937
  // We remove everything after the first ":" character so that our                                                    // 939
  // comparison logic ignores port numbers.                                                                            // 940
  var prefix = wildcardHost[0];                                                                                        // 941
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 942
  var hostSansPort = host.split(":")[0];                                                                               // 943
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 948
                                                                                                                       //
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 949
      return id;                                                                                                       // 950
    }                                                                                                                  // 951
  }                                                                                                                    // 952
                                                                                                                       //
  return null;                                                                                                         // 954
};                                                                                                                     // 955
                                                                                                                       //
makeWildcardHost = function (id) {                                                                                     // 957
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 958
};                                                                                                                     // 959
                                                                                                                       //
var isApiHostId = function (hostId) {                                                                                  // 961
  if (hostId) {                                                                                                        // 962
    var split = hostId.split("-");                                                                                     // 963
    if (split[0] === "api") return split[1] || "*";                                                                    // 964
  }                                                                                                                    // 965
                                                                                                                       //
  return false;                                                                                                        // 967
};                                                                                                                     // 968
                                                                                                                       //
var isTokenSpecificHostId = function (hostId) {                                                                        // 970
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 971
};                                                                                                                     // 972
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 974
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 975
  var Crypto = Npm.require("crypto");                                                                                  // 976
                                                                                                                       //
  apiHostIdHashForToken = function (token) {                                                                           // 977
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 978
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 980
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 981
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 982
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 983
    return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                                 // 984
  };                                                                                                                   // 985
} else {                                                                                                               // 986
  apiHostIdHashForToken = function (token) {                                                                           // 987
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 988
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 990
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 991
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 992
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 993
    return SHA256("x" + token).slice(0, 32);                                                                           // 994
  };                                                                                                                   // 995
}                                                                                                                      // 996
                                                                                                                       //
var apiHostIdForToken = function (token) {                                                                             // 998
  return "api-" + apiHostIdHashForToken(token);                                                                        // 999
};                                                                                                                     // 1000
                                                                                                                       //
var makeApiHost = function (token) {                                                                                   // 1002
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 1003
};                                                                                                                     // 1004
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1006
  var Url = Npm.require("url");                                                                                        // 1007
                                                                                                                       //
  getWildcardOrigin = function () {                                                                                    // 1008
    // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                        // 1009
    // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                      // 1010
    // an astrisk is only allowed as the first character and must be followed by a period. So we need                  // 1011
    // "*.example.com" instead -- which matches more than we actually want, but is the best we can                     // 1012
    // really do. We also add the protocol to the front (again, that's what CSP wants).                                // 1013
    // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                   // 1015
    var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                           // 1016
    var dotPos = wildcardHost[1].indexOf(".");                                                                         // 1018
                                                                                                                       //
    if (dotPos < 0) {                                                                                                  // 1019
      return protocol + "//*";                                                                                         // 1020
    } else {                                                                                                           // 1021
      return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                         // 1022
    }                                                                                                                  // 1023
  };                                                                                                                   // 1024
}                                                                                                                      // 1025
                                                                                                                       //
SandstormDb = function (quotaManager) {                                                                                // 1027
  // quotaManager is an object with the following method:                                                              // 1028
  //   updateUserQuota: It is provided two arguments                                                                   // 1029
  //     db: This SandstormDb object                                                                                   // 1030
  //     user: A collections.users account object                                                                      // 1031
  //   and returns a quota object:                                                                                     // 1032
  //     storage: A number (can be Infinity)                                                                           // 1033
  //     compute: A number (can be Infinity)                                                                           // 1034
  //     grains: A number (can be Infinity)                                                                            // 1035
  this.quotaManager = quotaManager;                                                                                    // 1037
  this.collections = {                                                                                                 // 1038
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    // 1039
    // collection globals directly.                                                                                    // 1040
    //                                                                                                                 // 1041
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      // 1042
    //   direct access to the collections.                                                                             // 1043
    users: Meteor.users,                                                                                               // 1044
    packages: Packages,                                                                                                // 1046
    devPackages: DevPackages,                                                                                          // 1047
    userActions: UserActions,                                                                                          // 1048
    grains: Grains,                                                                                                    // 1049
    roleAssignments: RoleAssignments,                                                                                  // 1050
    // Deprecated, only used by the migration that eliminated it.                                                      // 1050
    contacts: Contacts,                                                                                                // 1051
    sessions: Sessions,                                                                                                // 1052
    signupKeys: SignupKeys,                                                                                            // 1053
    activityStats: ActivityStats,                                                                                      // 1054
    deleteStats: DeleteStats,                                                                                          // 1055
    fileTokens: FileTokens,                                                                                            // 1056
    spkTokens: SpkTokens,                                                                                              // 1057
    apiTokens: ApiTokens,                                                                                              // 1058
    apiHosts: ApiHosts,                                                                                                // 1059
    notifications: Notifications,                                                                                      // 1060
    activitySubscriptions: ActivitySubscriptions,                                                                      // 1061
    statsTokens: StatsTokens,                                                                                          // 1062
    misc: Misc,                                                                                                        // 1063
    settings: Settings,                                                                                                // 1064
    migrations: Migrations,                                                                                            // 1065
    staticAssets: StaticAssets,                                                                                        // 1066
    assetUploadTokens: AssetUploadTokens,                                                                              // 1067
    plans: Plans,                                                                                                      // 1068
    appIndex: AppIndex,                                                                                                // 1069
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1070
    setupSession: SetupSession,                                                                                        // 1071
    desktopNotifications: DesktopNotifications,                                                                        // 1072
    standaloneDomains: StandaloneDomains                                                                               // 1073
  };                                                                                                                   // 1038
}; // TODO(cleanup): These methods should not be defined freestanding and should use collection                        // 1075
//   objects created in SandstormDb's constructor rather than globals.                                                 // 1078
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1080
  isAdmin: isAdmin,                                                                                                    // 1081
  isAdminById: isAdminById,                                                                                            // 1082
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1083
  matchWildcardHost: matchWildcardHost,                                                                                // 1084
  makeWildcardHost: makeWildcardHost,                                                                                  // 1085
  isApiHostId: isApiHostId,                                                                                            // 1086
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1087
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1088
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1089
  makeApiHost: makeApiHost,                                                                                            // 1090
  allowDevAccounts: function () {                                                                                      // 1091
    var setting = this.collections.settings.findOne({                                                                  // 1092
      _id: "devAccounts"                                                                                               // 1092
    });                                                                                                                // 1092
                                                                                                                       //
    if (setting) {                                                                                                     // 1093
      return setting.value;                                                                                            // 1094
    } else {                                                                                                           // 1095
      return Meteor.settings && Meteor.settings.public && Meteor.settings.public.allowDevAccounts;                     // 1096
    }                                                                                                                  // 1098
  },                                                                                                                   // 1099
  roleAssignmentPattern: {                                                                                             // 1101
    none: Match.Optional(null),                                                                                        // 1102
    allAccess: Match.Optional(null),                                                                                   // 1103
    roleId: Match.Optional(Match.Integer),                                                                             // 1104
    addPermissions: Match.Optional([Boolean]),                                                                         // 1105
    removePermissions: Match.Optional([Boolean])                                                                       // 1106
  },                                                                                                                   // 1101
  isDemoUser: function () {                                                                                            // 1109
    // Returns true if this is a demo user.                                                                            // 1110
    var user = Meteor.user();                                                                                          // 1112
                                                                                                                       //
    if (user && user.expires) {                                                                                        // 1113
      return true;                                                                                                     // 1114
    } else {                                                                                                           // 1115
      return false;                                                                                                    // 1116
    }                                                                                                                  // 1117
  },                                                                                                                   // 1118
  isSignedUp: function () {                                                                                            // 1120
    var user = Meteor.user();                                                                                          // 1121
    return this.isAccountSignedUp(user);                                                                               // 1122
  },                                                                                                                   // 1123
  isAccountSignedUp: function (user) {                                                                                 // 1125
    // Returns true if the user has presented an invite key.                                                           // 1126
    if (!user) return false; // not signed in                                                                          // 1128
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1130
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1132
                                                                                                                       //
    if (Meteor.settings.public.allowUninvited) return true; // all accounts qualify                                    // 1134
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1136
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1138
    return false;                                                                                                      // 1140
  },                                                                                                                   // 1141
  isSignedUpOrDemo: function () {                                                                                      // 1143
    var user = Meteor.user();                                                                                          // 1144
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1145
  },                                                                                                                   // 1146
  isAccountSignedUpOrDemo: function (user) {                                                                           // 1148
    if (!user) return false; // not signed in                                                                          // 1149
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1151
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1153
                                                                                                                       //
    if (Meteor.settings.public.allowUninvited) return true; // all accounts qualify                                    // 1155
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1157
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1159
    return false;                                                                                                      // 1161
  },                                                                                                                   // 1162
  isIdentityInOrganization: function (identity) {                                                                      // 1164
    if (!identity || !identity.services) {                                                                             // 1165
      return false;                                                                                                    // 1166
    }                                                                                                                  // 1167
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1169
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1170
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1171
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1172
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1173
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1174
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1175
                                                                                                                       //
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1176
      var domainSuffixes = emailDomain.split(/\s*,\s*/);                                                               // 1177
                                                                                                                       //
      for (var i = 0; i < domainSuffixes.length; i++) {                                                                // 1178
        var suffix = domainSuffixes[i];                                                                                // 1179
        var domain = identity.services.email.email.toLowerCase().split("@").pop();                                     // 1180
                                                                                                                       //
        if (suffix.startsWith("*.")) {                                                                                 // 1181
          if (domain.endsWith(suffix.substr(1))) {                                                                     // 1182
            return true;                                                                                               // 1183
          }                                                                                                            // 1184
        } else if (domain === suffix) {                                                                                // 1185
          return true;                                                                                                 // 1186
        }                                                                                                              // 1187
      }                                                                                                                // 1188
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1189
      return true;                                                                                                     // 1190
    } else if (samlEnabled && identity.services.saml) {                                                                // 1191
      return true;                                                                                                     // 1192
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1193
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1194
        return true;                                                                                                   // 1195
      }                                                                                                                // 1196
    }                                                                                                                  // 1197
                                                                                                                       //
    return false;                                                                                                      // 1199
  },                                                                                                                   // 1200
  isUserInOrganization: function (user) {                                                                              // 1202
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1203
      var identity = Meteor.users.findOne({                                                                            // 1204
        _id: user.loginIdentities[i].id                                                                                // 1204
      });                                                                                                              // 1204
                                                                                                                       //
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1205
        return true;                                                                                                   // 1206
      }                                                                                                                // 1207
    }                                                                                                                  // 1208
                                                                                                                       //
    return false;                                                                                                      // 1210
  }                                                                                                                    // 1211
});                                                                                                                    // 1080
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1214
  SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                         // 1215
                                                                                                                       //
  var _Crypto = Npm.require("crypto");                                                                                 // 1217
                                                                                                                       //
  SandstormDb.prototype.removeApiTokens = function (query) {                                                           // 1218
    var _this2 = this;                                                                                                 // 1218
                                                                                                                       //
    // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                             // 1219
    this.collections.apiTokens.find(query).forEach(function (token) {                                                  // 1221
      // Clean up ApiHosts for webkey tokens.                                                                          // 1222
      if (token.hasApiHost) {                                                                                          // 1223
        var hash2 = _Crypto.createHash("sha256").update(token._id).digest("base64");                                   // 1224
                                                                                                                       //
        _this2.collections.apiHosts.remove({                                                                           // 1225
          hash2: hash2                                                                                                 // 1225
        });                                                                                                            // 1225
      } // TODO(soon): Drop remote OAuth tokens for frontendRef.http. Unfortunately the way to do                      // 1226
      //   this is different for every service. :( Also we may need to clarify with the "bearer"                       // 1229
      //   type whether or not the token is "owned" by us...                                                           // 1230
                                                                                                                       //
    });                                                                                                                // 1231
    this.collections.apiTokens.remove(query);                                                                          // 1233
  };                                                                                                                   // 1234
} // TODO(someday): clean this up.  Logic for building static asset urls on client and server                          // 1235
// appears all over the codebase.                                                                                      // 1238
                                                                                                                       //
                                                                                                                       //
var httpProtocol = void 0;                                                                                             // 1239
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1240
  var _Url = Npm.require("url");                                                                                       // 1241
                                                                                                                       //
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1242
} else {                                                                                                               // 1243
  httpProtocol = window.location.protocol;                                                                             // 1244
} // =======================================================================================                           // 1245
// Below this point are newly-written or refactored functions.                                                         // 1248
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1250
  getUser: function (userId) {                                                                                         // 1251
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1252
                                                                                                                       //
    if (userId) {                                                                                                      // 1253
      return Meteor.users.findOne(userId);                                                                             // 1254
    }                                                                                                                  // 1255
  },                                                                                                                   // 1256
  getIdentity: function (identityId) {                                                                                 // 1258
    check(identityId, String);                                                                                         // 1259
    var identity = Meteor.users.findOne({                                                                              // 1260
      _id: identityId                                                                                                  // 1260
    });                                                                                                                // 1260
                                                                                                                       //
    if (identity) {                                                                                                    // 1261
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1262
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1263
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1264
      return identity;                                                                                                 // 1265
    }                                                                                                                  // 1266
  },                                                                                                                   // 1267
  userHasIdentity: function (userId, identityId) {                                                                     // 1269
    check(userId, String);                                                                                             // 1270
    check(identityId, String);                                                                                         // 1271
    if (userId === identityId) return true;                                                                            // 1273
    var user = Meteor.users.findOne(userId);                                                                           // 1275
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1276
  },                                                                                                                   // 1277
  userGrains: function (userId, options) {                                                                             // 1279
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1280
    check(options, Match.OneOf(undefined, null, {                                                                      // 1281
      includeTrashOnly: Match.Optional(Boolean),                                                                       // 1282
      includeTrash: Match.Optional(Boolean)                                                                            // 1282
    }));                                                                                                               // 1282
    var query = {                                                                                                      // 1284
      userId: userId                                                                                                   // 1284
    };                                                                                                                 // 1284
                                                                                                                       //
    if (options && options.includeTrashOnly) {                                                                         // 1285
      query.trashed = {                                                                                                // 1286
        $exists: true                                                                                                  // 1286
      };                                                                                                               // 1286
    } else if (options && options.includeTrash) {// Keep query as-is.                                                  // 1287
    } else {                                                                                                           // 1289
      query.trashed = {                                                                                                // 1290
        $exists: false                                                                                                 // 1290
      };                                                                                                               // 1290
    }                                                                                                                  // 1291
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1293
  },                                                                                                                   // 1294
  currentUserGrains: function (options) {                                                                              // 1296
    return this.userGrains(Meteor.userId(), options);                                                                  // 1297
  },                                                                                                                   // 1298
  getGrain: function (grainId) {                                                                                       // 1300
    check(grainId, String);                                                                                            // 1301
    return this.collections.grains.findOne(grainId);                                                                   // 1302
  },                                                                                                                   // 1303
  userApiTokens: function (userId, trashed) {                                                                          // 1305
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1306
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1307
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1308
    return this.collections.apiTokens.find({                                                                           // 1309
      "owner.user.identityId": {                                                                                       // 1310
        $in: identityIds                                                                                               // 1310
      },                                                                                                               // 1310
      trashed: {                                                                                                       // 1311
        $exists: !!trashed                                                                                             // 1311
      }                                                                                                                // 1311
    });                                                                                                                // 1309
  },                                                                                                                   // 1313
  currentUserApiTokens: function (trashed) {                                                                           // 1315
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1316
  },                                                                                                                   // 1317
  userActions: function (user) {                                                                                       // 1319
    return this.collections.userActions.find({                                                                         // 1320
      userId: user                                                                                                     // 1320
    });                                                                                                                // 1320
  },                                                                                                                   // 1321
  currentUserActions: function () {                                                                                    // 1323
    return this.userActions(Meteor.userId());                                                                          // 1324
  },                                                                                                                   // 1325
  iconSrcForPackage: function (pkg, usage) {                                                                           // 1327
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1328
  },                                                                                                                   // 1329
  getDenormalizedGrainInfo: function (grainId) {                                                                       // 1331
    var grain = this.getGrain(grainId);                                                                                // 1332
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1333
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1335
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1336
    }                                                                                                                  // 1337
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || {                                                   // 1339
      defaultText: ""                                                                                                  // 1339
    };                                                                                                                 // 1339
    var grainInfo = {                                                                                                  // 1340
      appTitle: appTitle                                                                                               // 1340
    };                                                                                                                 // 1340
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1342
      var icons = pkg.manifest.metadata.icons;                                                                         // 1343
      var icon = icons.grain || icons.appGrid;                                                                         // 1344
                                                                                                                       //
      if (icon) {                                                                                                      // 1345
        grainInfo.icon = icon;                                                                                         // 1346
      }                                                                                                                // 1347
    } // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                    // 1348
                                                                                                                       //
                                                                                                                       //
    if (!grainInfo.icon && pkg) {                                                                                      // 1351
      grainInfo.appId = pkg.appId;                                                                                     // 1352
    }                                                                                                                  // 1353
                                                                                                                       //
    return grainInfo;                                                                                                  // 1355
  },                                                                                                                   // 1356
  getPlan: function (id, user) {                                                                                       // 1358
    check(id, String); // `user`, if provided, is the user observing the plan. This matters only for checking if the   // 1359
    // user is in an experiment.                                                                                       // 1362
                                                                                                                       //
    var plan = this.collections.plans.findOne(id);                                                                     // 1364
                                                                                                                       //
    if (!plan) {                                                                                                       // 1365
      throw new Error("no such plan: " + id);                                                                          // 1366
    }                                                                                                                  // 1367
                                                                                                                       //
    if (plan._id === "free") {                                                                                         // 1369
      user = user || Meteor.user();                                                                                    // 1370
                                                                                                                       //
      if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                           // 1371
        plan.grains = user.experiments.freeGrainLimit;                                                                 // 1373
      }                                                                                                                // 1374
    }                                                                                                                  // 1375
                                                                                                                       //
    return plan;                                                                                                       // 1377
  },                                                                                                                   // 1378
  listPlans: function (user) {                                                                                         // 1380
    user = user || Meteor.user();                                                                                      // 1381
                                                                                                                       //
    if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                             // 1382
      return this.collections.plans.find({}, {                                                                         // 1384
        sort: {                                                                                                        // 1384
          price: 1                                                                                                     // 1384
        }                                                                                                              // 1384
      }).map(function (plan) {                                                                                         // 1384
        if (plan._id === "free") {                                                                                     // 1386
          plan.grains = user.experiments.freeGrainLimit;                                                               // 1387
        }                                                                                                              // 1388
                                                                                                                       //
        return plan;                                                                                                   // 1390
      });                                                                                                              // 1391
    } else {                                                                                                           // 1392
      return this.collections.plans.find({}, {                                                                         // 1393
        sort: {                                                                                                        // 1393
          price: 1                                                                                                     // 1393
        }                                                                                                              // 1393
      }).fetch();                                                                                                      // 1393
    }                                                                                                                  // 1394
  },                                                                                                                   // 1395
  getMyPlan: function () {                                                                                             // 1397
    var user = Meteor.user();                                                                                          // 1398
    return user && this.collections.plans.findOne(user.plan || "free");                                                // 1399
  },                                                                                                                   // 1400
  getMyReferralBonus: function (user) {                                                                                // 1402
    // This function is called from the server and from the client, similar to getMyPlan().                            // 1403
    //                                                                                                                 // 1404
    // The parameter may be omitted in which case the current user is assumed.                                         // 1405
    return calculateReferralBonus(user || Meteor.user());                                                              // 1407
  },                                                                                                                   // 1408
  getMyUsage: function (user) {                                                                                        // 1410
    user = user || Meteor.user();                                                                                      // 1411
                                                                                                                       //
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1412
      if (Meteor.isClient) {                                                                                           // 1413
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       // 1414
        // not reactive.                                                                                               // 1415
        return user.pseudoUsage;                                                                                       // 1416
      } else {                                                                                                         // 1417
        return {                                                                                                       // 1418
          grains: this.collections.grains.find({                                                                       // 1419
            userId: user._id                                                                                           // 1419
          }).count(),                                                                                                  // 1419
          storage: user.storageUsage || 0,                                                                             // 1420
          compute: 0                                                                                                   // 1421
        };                                                                                                             // 1418
      }                                                                                                                // 1423
    } else {                                                                                                           // 1424
      return {                                                                                                         // 1425
        grains: 0,                                                                                                     // 1425
        storage: 0,                                                                                                    // 1425
        compute: 0                                                                                                     // 1425
      };                                                                                                               // 1425
    }                                                                                                                  // 1426
  },                                                                                                                   // 1427
  isUninvitedFreeUser: function () {                                                                                   // 1429
    if (!Meteor.settings.public.allowUninvited) return false;                                                          // 1430
    var user = Meteor.user();                                                                                          // 1432
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1433
  },                                                                                                                   // 1434
  getSetting: function (name) {                                                                                        // 1436
    var setting = this.collections.settings.findOne(name);                                                             // 1437
    return setting && setting.value;                                                                                   // 1438
  },                                                                                                                   // 1439
  getSettingWithFallback: function (name, fallbackValue) {                                                             // 1441
    var value = this.getSetting(name);                                                                                 // 1442
                                                                                                                       //
    if (value === undefined) {                                                                                         // 1443
      return fallbackValue;                                                                                            // 1444
    }                                                                                                                  // 1445
                                                                                                                       //
    return value;                                                                                                      // 1447
  },                                                                                                                   // 1448
  addUserActions: function (userId, packageId, simulation) {                                                           // 1450
    check(userId, String);                                                                                             // 1451
    check(packageId, String);                                                                                          // 1452
    var pack = this.collections.packages.findOne({                                                                     // 1454
      _id: packageId                                                                                                   // 1454
    });                                                                                                                // 1454
                                                                                                                       //
    if (pack) {                                                                                                        // 1455
      // Remove old versions.                                                                                          // 1456
      var numRemoved = this.collections.userActions.remove({                                                           // 1457
        userId: userId,                                                                                                // 1457
        appId: pack.appId                                                                                              // 1457
      }); // Install new.                                                                                              // 1457
                                                                                                                       //
      var actions = pack.manifest.actions;                                                                             // 1460
                                                                                                                       //
      for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                                 // 1461
        var action = actions[i];                                                                                       // 1462
                                                                                                                       //
        if ("none" in action.input) {                                                                                  // 1463
          var userAction = {                                                                                           // 1464
            userId: userId,                                                                                            // 1465
            packageId: pack._id,                                                                                       // 1466
            appId: pack.appId,                                                                                         // 1467
            appTitle: pack.manifest.appTitle,                                                                          // 1468
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1469
            appVersion: pack.manifest.appVersion,                                                                      // 1470
            title: action.title,                                                                                       // 1471
            nounPhrase: action.nounPhrase,                                                                             // 1472
            command: action.command                                                                                    // 1473
          };                                                                                                           // 1464
          this.collections.userActions.insert(userAction);                                                             // 1475
        } else {// TODO(someday):  Implement actions with capability inputs.                                           // 1476
        }                                                                                                              // 1478
      }                                                                                                                // 1479
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1481
        this.deleteUnusedPackages(pack.appId);                                                                         // 1482
      }                                                                                                                // 1483
    }                                                                                                                  // 1484
  },                                                                                                                   // 1485
  sendAdminNotification: function (type, action) {                                                                     // 1487
    Meteor.users.find({                                                                                                // 1488
      isAdmin: true                                                                                                    // 1488
    }, {                                                                                                               // 1488
      fields: {                                                                                                        // 1488
        _id: 1                                                                                                         // 1488
      }                                                                                                                // 1488
    }).forEach(function (user) {                                                                                       // 1488
      Notifications.insert({                                                                                           // 1489
        admin: {                                                                                                       // 1490
          action: action,                                                                                              // 1490
          type: type                                                                                                   // 1490
        },                                                                                                             // 1490
        userId: user._id,                                                                                              // 1491
        timestamp: new Date(),                                                                                         // 1492
        isUnread: true                                                                                                 // 1493
      });                                                                                                              // 1489
    });                                                                                                                // 1495
  },                                                                                                                   // 1496
  getKeybaseProfile: function (keyFingerprint) {                                                                       // 1498
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1499
  },                                                                                                                   // 1500
  getServerTitle: function () {                                                                                        // 1502
    var setting = this.collections.settings.findOne({                                                                  // 1503
      _id: "serverTitle"                                                                                               // 1503
    });                                                                                                                // 1503
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1504
  },                                                                                                                   // 1505
  getSmtpConfig: function () {                                                                                         // 1507
    var setting = this.collections.settings.findOne({                                                                  // 1508
      _id: "smtpConfig"                                                                                                // 1508
    });                                                                                                                // 1508
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1509
  },                                                                                                                   // 1510
  getReturnAddress: function () {                                                                                      // 1512
    var config = this.getSmtpConfig();                                                                                 // 1513
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1514
  },                                                                                                                   // 1515
  getReturnAddressWithDisplayName: function (identityId) {                                                             // 1517
    check(identityId, String);                                                                                         // 1518
    var identity = this.getIdentity(identityId);                                                                       // 1519
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")"; // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,
    // we could escape such characters with a backslash, but that does not seem to help here.                          // 1523
    // TODO(cleanup): Unclear whether this sanitization is still necessary now that we return a                        // 1524
    //   structured object and have moved to nodemailer. I'm not touching it for now.                                  // 1525
                                                                                                                       //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1526
    return {                                                                                                           // 1528
      name: sanitized,                                                                                                 // 1528
      address: this.getReturnAddress()                                                                                 // 1528
    };                                                                                                                 // 1528
  },                                                                                                                   // 1529
  getPrimaryEmail: function (accountId, identityId) {                                                                  // 1531
    check(accountId, String);                                                                                          // 1532
    check(identityId, String);                                                                                         // 1533
    var identity = this.getIdentity(identityId);                                                                       // 1535
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1536
                                                                                                                       //
    var senderPrimaryEmail = _.findWhere(senderEmails, {                                                               // 1537
      primary: true                                                                                                    // 1537
    });                                                                                                                // 1537
                                                                                                                       //
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1538
                                                                                                                       //
    if (_.findWhere(senderEmails, {                                                                                    // 1539
      email: accountPrimaryEmailAddress                                                                                // 1539
    })) {                                                                                                              // 1539
      return accountPrimaryEmailAddress;                                                                               // 1540
    } else if (senderPrimaryEmail) {                                                                                   // 1541
      return senderPrimaryEmail.email;                                                                                 // 1542
    } else {                                                                                                           // 1543
      return null;                                                                                                     // 1544
    }                                                                                                                  // 1545
  },                                                                                                                   // 1546
  incrementDailySentMailCount: function (accountId) {                                                                  // 1548
    check(accountId, String);                                                                                          // 1549
    var DAILY_LIMIT = 50;                                                                                              // 1551
    var result = Meteor.users.findAndModify({                                                                          // 1552
      query: {                                                                                                         // 1553
        _id: accountId                                                                                                 // 1553
      },                                                                                                               // 1553
      update: {                                                                                                        // 1554
        $inc: {                                                                                                        // 1555
          dailySentMailCount: 1                                                                                        // 1556
        }                                                                                                              // 1555
      },                                                                                                               // 1554
      fields: {                                                                                                        // 1559
        dailySentMailCount: 1                                                                                          // 1559
      }                                                                                                                // 1559
    });                                                                                                                // 1552
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1562
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1563
    }                                                                                                                  // 1564
                                                                                                                       //
    var user = result.value;                                                                                           // 1566
                                                                                                                       //
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1567
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1572
  },                                                                                                                   // 1573
  getLdapUrl: function () {                                                                                            // 1575
    var setting = this.collections.settings.findOne({                                                                  // 1576
      _id: "ldapUrl"                                                                                                   // 1576
    });                                                                                                                // 1576
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1577
  },                                                                                                                   // 1578
  getLdapBase: function () {                                                                                           // 1580
    var setting = this.collections.settings.findOne({                                                                  // 1581
      _id: "ldapBase"                                                                                                  // 1581
    });                                                                                                                // 1581
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1582
  },                                                                                                                   // 1583
  getLdapDnPattern: function () {                                                                                      // 1585
    var setting = this.collections.settings.findOne({                                                                  // 1586
      _id: "ldapDnPattern"                                                                                             // 1586
    });                                                                                                                // 1586
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1587
  },                                                                                                                   // 1588
  getLdapSearchUsername: function () {                                                                                 // 1590
    var setting = this.collections.settings.findOne({                                                                  // 1591
      _id: "ldapSearchUsername"                                                                                        // 1591
    });                                                                                                                // 1591
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1592
  },                                                                                                                   // 1593
  getLdapNameField: function () {                                                                                      // 1595
    var setting = this.collections.settings.findOne({                                                                  // 1596
      _id: "ldapNameField"                                                                                             // 1596
    });                                                                                                                // 1596
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1597
  },                                                                                                                   // 1598
  getLdapEmailField: function () {                                                                                     // 1600
    var setting = this.collections.settings.findOne({                                                                  // 1601
      _id: "ldapEmailField"                                                                                            // 1601
    });                                                                                                                // 1601
    return setting ? setting.value : "mail"; // default to "mail". This setting was added later, and so could potentially be unset.
  },                                                                                                                   // 1604
  getLdapExplicitDnSelected: function () {                                                                             // 1606
    var setting = this.collections.settings.findOne({                                                                  // 1607
      _id: "ldapExplicitDnSelected"                                                                                    // 1607
    });                                                                                                                // 1607
    return setting && setting.value;                                                                                   // 1608
  },                                                                                                                   // 1609
  getLdapFilter: function () {                                                                                         // 1611
    var setting = this.collections.settings.findOne({                                                                  // 1612
      _id: "ldapFilter"                                                                                                // 1612
    });                                                                                                                // 1612
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1613
  },                                                                                                                   // 1614
  getLdapSearchBindDn: function () {                                                                                   // 1616
    var setting = this.collections.settings.findOne({                                                                  // 1617
      _id: "ldapSearchBindDn"                                                                                          // 1617
    });                                                                                                                // 1617
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1618
  },                                                                                                                   // 1619
  getLdapSearchBindPassword: function () {                                                                             // 1621
    var setting = this.collections.settings.findOne({                                                                  // 1622
      _id: "ldapSearchBindPassword"                                                                                    // 1622
    });                                                                                                                // 1622
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1623
  },                                                                                                                   // 1624
  getLdapCaCert: function () {                                                                                         // 1626
    var setting = this.collections.settings.findOne({                                                                  // 1627
      _id: "ldapCaCert"                                                                                                // 1627
    });                                                                                                                // 1627
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1628
  },                                                                                                                   // 1629
  getOrganizationMembership: function () {                                                                             // 1631
    var setting = this.collections.settings.findOne({                                                                  // 1632
      _id: "organizationMembership"                                                                                    // 1632
    });                                                                                                                // 1632
    return setting && setting.value;                                                                                   // 1633
  },                                                                                                                   // 1634
  getOrganizationEmailEnabled: function () {                                                                           // 1636
    var membership = this.getOrganizationMembership();                                                                 // 1637
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1638
  },                                                                                                                   // 1639
  getOrganizationEmailDomain: function () {                                                                            // 1641
    var membership = this.getOrganizationMembership();                                                                 // 1642
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1643
  },                                                                                                                   // 1644
  getOrganizationGoogleEnabled: function () {                                                                          // 1646
    var membership = this.getOrganizationMembership();                                                                 // 1647
    return membership && membership.google && membership.google.enabled;                                               // 1648
  },                                                                                                                   // 1649
  getOrganizationGoogleDomain: function () {                                                                           // 1651
    var membership = this.getOrganizationMembership();                                                                 // 1652
    return membership && membership.google && membership.google.domain;                                                // 1653
  },                                                                                                                   // 1654
  getOrganizationLdapEnabled: function () {                                                                            // 1656
    var membership = this.getOrganizationMembership();                                                                 // 1657
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1658
  },                                                                                                                   // 1659
  getOrganizationSamlEnabled: function () {                                                                            // 1661
    var membership = this.getOrganizationMembership();                                                                 // 1662
    return membership && membership.saml && membership.saml.enabled;                                                   // 1663
  },                                                                                                                   // 1664
  getOrganizationDisallowGuests: function () {                                                                         // 1666
    return this.getOrganizationDisallowGuestsRaw();                                                                    // 1667
  },                                                                                                                   // 1668
  getOrganizationDisallowGuestsRaw: function () {                                                                      // 1670
    var setting = this.collections.settings.findOne({                                                                  // 1671
      _id: "organizationSettings"                                                                                      // 1671
    });                                                                                                                // 1671
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1672
  },                                                                                                                   // 1673
  getOrganizationShareContacts: function () {                                                                          // 1675
    return this.getOrganizationShareContactsRaw();                                                                     // 1676
  },                                                                                                                   // 1677
  getOrganizationShareContactsRaw: function () {                                                                       // 1679
    var setting = this.collections.settings.findOne({                                                                  // 1680
      _id: "organizationSettings"                                                                                      // 1680
    });                                                                                                                // 1680
                                                                                                                       //
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1681
      // default to true if undefined                                                                                  // 1682
      return true;                                                                                                     // 1683
    } else {                                                                                                           // 1684
      return setting.value.shareContacts;                                                                              // 1685
    }                                                                                                                  // 1686
  },                                                                                                                   // 1687
  getSamlEntryPoint: function () {                                                                                     // 1689
    var setting = this.collections.settings.findOne({                                                                  // 1690
      _id: "samlEntryPoint"                                                                                            // 1690
    });                                                                                                                // 1690
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1691
  },                                                                                                                   // 1692
  getSamlLogout: function () {                                                                                         // 1694
    var setting = this.collections.settings.findOne({                                                                  // 1695
      _id: "samlLogout"                                                                                                // 1695
    });                                                                                                                // 1695
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1696
  },                                                                                                                   // 1697
  getSamlPublicCert: function () {                                                                                     // 1699
    var setting = this.collections.settings.findOne({                                                                  // 1700
      _id: "samlPublicCert"                                                                                            // 1700
    });                                                                                                                // 1700
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1701
  },                                                                                                                   // 1702
  getSamlEntityId: function () {                                                                                       // 1704
    var setting = this.collections.settings.findOne({                                                                  // 1705
      _id: "samlEntityId"                                                                                              // 1705
    });                                                                                                                // 1705
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1706
  },                                                                                                                   // 1707
  userHasSamlLoginIdentity: function () {                                                                              // 1709
    var user = Meteor.user();                                                                                          // 1710
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 1711
      return false;                                                                                                    // 1712
    }                                                                                                                  // 1713
                                                                                                                       //
    var hasSaml = false;                                                                                               // 1715
    user.loginIdentities.forEach(function (identity) {                                                                 // 1716
      if (Meteor.users.findOne({                                                                                       // 1717
        _id: identity.id                                                                                               // 1717
      }).services.saml) {                                                                                              // 1717
        hasSaml = true;                                                                                                // 1718
      }                                                                                                                // 1719
    });                                                                                                                // 1720
    return hasSaml;                                                                                                    // 1722
  },                                                                                                                   // 1723
  getActivitySubscriptions: function (grainId, threadPath) {                                                           // 1725
    return this.collections.activitySubscriptions.find({                                                               // 1726
      grainId: grainId,                                                                                                // 1727
      threadPath: threadPath || {                                                                                      // 1728
        $exists: false                                                                                                 // 1728
      }                                                                                                                // 1728
    }, {                                                                                                               // 1726
      fields: {                                                                                                        // 1730
        identityId: 1,                                                                                                 // 1730
        mute: 1,                                                                                                       // 1730
        _id: 0                                                                                                         // 1730
      }                                                                                                                // 1730
    }).fetch();                                                                                                        // 1729
  },                                                                                                                   // 1732
  subscribeToActivity: function (identityId, grainId, threadPath) {                                                    // 1734
    // Subscribe the given identity to activity events with the given grainId and (optional)                           // 1735
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        // 1736
    // case do nothing.                                                                                                // 1737
    var record = {                                                                                                     // 1739
      identityId: identityId,                                                                                          // 1739
      grainId: grainId                                                                                                 // 1739
    };                                                                                                                 // 1739
                                                                                                                       //
    if (threadPath) {                                                                                                  // 1740
      record.threadPath = threadPath;                                                                                  // 1741
    } // The $set here is redundant since an upsert automatically initializes a new record to contain                  // 1742
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      // 1745
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    // 1746
    // What a wonderful query language.                                                                                // 1747
                                                                                                                       //
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, {                                                            // 1748
      $set: record                                                                                                     // 1748
    });                                                                                                                // 1748
  },                                                                                                                   // 1749
  muteActivity: function (identityId, grainId, threadPath) {                                                           // 1751
    // Mute notifications for the given identity originating from the given grainId and                                // 1752
    // (optional) threadPath.                                                                                          // 1753
    var record = {                                                                                                     // 1755
      identityId: identityId,                                                                                          // 1755
      grainId: grainId                                                                                                 // 1755
    };                                                                                                                 // 1755
                                                                                                                       //
    if (threadPath) {                                                                                                  // 1756
      record.threadPath = threadPath;                                                                                  // 1757
    }                                                                                                                  // 1758
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, {                                                            // 1760
      $set: {                                                                                                          // 1760
        mute: true                                                                                                     // 1760
      }                                                                                                                // 1760
    });                                                                                                                // 1760
  },                                                                                                                   // 1761
  updateAppIndex: function () {                                                                                        // 1763
    var _this3 = this;                                                                                                 // 1763
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({                                                 // 1764
      _id: "appUpdatesEnabled"                                                                                         // 1764
    });                                                                                                                // 1764
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1765
                                                                                                                       //
    if (!appUpdatesEnabled) {                                                                                          // 1766
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       // 1767
      // timer that triggers this call.                                                                                // 1768
      return;                                                                                                          // 1769
    }                                                                                                                  // 1770
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({                                                              // 1772
      _id: "appIndexUrl"                                                                                               // 1772
    }).value;                                                                                                          // 1772
    var appIndex = this.collections.appIndex;                                                                          // 1773
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1774
    var preinstalledAppIds = this.getAllPreinstalledAppIds(); // We make sure to get all preinstalled appIds, even ones that are currently
    // downloading/failed.                                                                                             // 1777
                                                                                                                       //
    data.apps.forEach(function (app) {                                                                                 // 1778
      app._id = app.appId;                                                                                             // 1779
      var oldApp = appIndex.findOne({                                                                                  // 1781
        _id: app.appId                                                                                                 // 1781
      });                                                                                                              // 1781
      app.hasSentNotifications = false;                                                                                // 1782
      appIndex.upsert({                                                                                                // 1783
        _id: app._id                                                                                                   // 1783
      }, app);                                                                                                         // 1783
                                                                                                                       //
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1784
                                                                                                                       //
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({           // 1785
        appId: app.appId                                                                                               // 1786
      }) || isAppPreinstalled)) {                                                                                      // 1786
        var pack = _this3.collections.packages.findOne({                                                               // 1788
          _id: app.packageId                                                                                           // 1788
        });                                                                                                            // 1788
                                                                                                                       //
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1789
                                                                                                                       //
        if (pack) {                                                                                                    // 1790
          if (pack.status === "ready") {                                                                               // 1791
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1792
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1793
            } else {                                                                                                   // 1795
              _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1796
                                                                                                                       //
              if (isAppPreinstalled) {                                                                                 // 1798
                _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                              // 1799
              }                                                                                                        // 1800
            }                                                                                                          // 1801
          } else {                                                                                                     // 1802
            var result = _this3.collections.packages.findAndModify({                                                   // 1803
              query: {                                                                                                 // 1804
                _id: app.packageId                                                                                     // 1804
              },                                                                                                       // 1804
              update: {                                                                                                // 1805
                $set: {                                                                                                // 1805
                  isAutoUpdated: true                                                                                  // 1805
                }                                                                                                      // 1805
              }                                                                                                        // 1805
            });                                                                                                        // 1803
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1808
              return;                                                                                                  // 1809
            }                                                                                                          // 1810
                                                                                                                       //
            var newPack = result.value;                                                                                // 1812
                                                                                                                       //
            if (newPack.status === "ready") {                                                                          // 1813
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  // 1814
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  // 1815
              // fine, since it will de-dupe).                                                                         // 1816
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1817
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1818
              } else {                                                                                                 // 1820
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                                                                                                                       //
                if (isAppPreinstalled) {                                                                               // 1823
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1824
                }                                                                                                      // 1825
              }                                                                                                        // 1826
            } else if (newPack.status === "failed") {                                                                  // 1827
              // If the package has failed, retry it                                                                   // 1828
              _this3.startInstall(app.packageId, url, true, true);                                                     // 1829
            }                                                                                                          // 1830
          }                                                                                                            // 1831
        } else {                                                                                                       // 1832
          _this3.startInstall(app.packageId, url, false, true);                                                        // 1833
        }                                                                                                              // 1834
      }                                                                                                                // 1835
    });                                                                                                                // 1836
  },                                                                                                                   // 1837
  isPackagePreinstalled: function (packageId) {                                                                        // 1839
    return this.collections.settings.find({                                                                            // 1840
      _id: "preinstalledApps",                                                                                         // 1840
      "value.packageId": packageId                                                                                     // 1840
    }).count() === 1;                                                                                                  // 1840
  },                                                                                                                   // 1841
  getAppIdForPreinstalledPackage: function (packageId) {                                                               // 1843
    var setting = this.collections.settings.findOne({                                                                  // 1844
      _id: "preinstalledApps",                                                                                         // 1844
      "value.packageId": packageId                                                                                     // 1844
    }, {                                                                                                               // 1844
      fields: {                                                                                                        // 1845
        "value.$": 1                                                                                                   // 1845
      }                                                                                                                // 1845
    }); // value.$ causes mongo to transform the result and only return the first matching element in                  // 1845
    // the array                                                                                                       // 1847
                                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1848
  },                                                                                                                   // 1849
  getPackageIdForPreinstalledApp: function (appId) {                                                                   // 1851
    var setting = this.collections.settings.findOne({                                                                  // 1852
      _id: "preinstalledApps",                                                                                         // 1852
      "value.appId": appId                                                                                             // 1852
    }, {                                                                                                               // 1852
      fields: {                                                                                                        // 1853
        "value.$": 1                                                                                                   // 1853
      }                                                                                                                // 1853
    }); // value.$ causes mongo to transform the result and only return the first matching element in                  // 1853
    // the array                                                                                                       // 1855
                                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1856
  },                                                                                                                   // 1857
  getReadyPreinstalledAppIds: function () {                                                                            // 1859
    var setting = this.collections.settings.findOne({                                                                  // 1860
      _id: "preinstalledApps"                                                                                          // 1860
    });                                                                                                                // 1860
    var ret = setting && setting.value || [];                                                                          // 1861
    return _.chain(ret).filter(function (app) {                                                                        // 1862
      return app.status === "ready";                                                                                   // 1863
    }).map(function (app) {                                                                                            // 1863
      return app.appId;                                                                                                // 1864
    }).value();                                                                                                        // 1864
  },                                                                                                                   // 1866
  getAllPreinstalledAppIds: function () {                                                                              // 1868
    var setting = this.collections.settings.findOne({                                                                  // 1869
      _id: "preinstalledApps"                                                                                          // 1869
    });                                                                                                                // 1869
    var ret = setting && setting.value || [];                                                                          // 1870
    return _.map(ret, function (app) {                                                                                 // 1871
      return app.appId;                                                                                                // 1871
    });                                                                                                                // 1871
  },                                                                                                                   // 1872
  preinstallAppsForUser: function (userId) {                                                                           // 1874
    var _this4 = this;                                                                                                 // 1874
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1875
    appIds.forEach(function (appId) {                                                                                  // 1876
      try {                                                                                                            // 1877
        _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                   // 1878
      } catch (e) {                                                                                                    // 1879
        console.error("failed to install app for user:", e);                                                           // 1880
      }                                                                                                                // 1881
    });                                                                                                                // 1882
  },                                                                                                                   // 1883
  setPreinstallAppAsDownloading: function (appId, packageId) {                                                         // 1885
    this.collections.settings.update({                                                                                 // 1886
      _id: "preinstalledApps",                                                                                         // 1887
      "value.appId": appId,                                                                                            // 1887
      "value.packageId": packageId                                                                                     // 1887
    }, {                                                                                                               // 1887
      $set: {                                                                                                          // 1888
        "value.$.status": "downloading"                                                                                // 1888
      }                                                                                                                // 1888
    });                                                                                                                // 1888
  },                                                                                                                   // 1889
  setPreinstallAppAsReady: function (appId, packageId) {                                                               // 1891
    // This function both sets the appId as ready and updates the packageId for the given appId                        // 1892
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            // 1893
    // latest installed package will be set as ready.                                                                  // 1894
    this.collections.settings.update({                                                                                 // 1895
      _id: "preinstalledApps",                                                                                         // 1896
      "value.appId": appId                                                                                             // 1896
    }, {                                                                                                               // 1896
      $set: {                                                                                                          // 1897
        "value.$.status": "ready",                                                                                     // 1897
        "value.$.packageId": packageId                                                                                 // 1897
      }                                                                                                                // 1897
    });                                                                                                                // 1897
  },                                                                                                                   // 1898
  ensureAppPreinstall: function (appId, packageId) {                                                                   // 1900
    check(appId, String);                                                                                              // 1901
    var appIndexUrl = this.collections.settings.findOne({                                                              // 1902
      _id: "appIndexUrl"                                                                                               // 1902
    }).value;                                                                                                          // 1902
    var pack = this.collections.packages.findOne({                                                                     // 1903
      _id: packageId                                                                                                   // 1903
    });                                                                                                                // 1903
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1904
                                                                                                                       //
    if (pack && pack.status === "ready") {                                                                             // 1905
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1906
    } else if (pack && pack.status === "failed") {                                                                     // 1907
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1908
      this.startInstall(packageId, url, true, false);                                                                  // 1909
    } else {                                                                                                           // 1910
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1911
      this.startInstall(packageId, url, false, false);                                                                 // 1912
    }                                                                                                                  // 1913
  },                                                                                                                   // 1914
  setPreinstalledApps: function (appAndPackageIds) {                                                                   // 1916
    var _this5 = this;                                                                                                 // 1916
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 // 1917
    //     appId: The Packages.appId of the app to install                                                             // 1918
    //     packageId: The Packages._id of the app to install                                                           // 1919
    check(appAndPackageIds, [{                                                                                         // 1920
      appId: String,                                                                                                   // 1920
      packageId: String                                                                                                // 1920
    }]); // Start by clearing out the setting. We'll push appIds one by one to it                                      // 1920
                                                                                                                       //
    this.collections.settings.upsert({                                                                                 // 1923
      _id: "preinstalledApps"                                                                                          // 1923
    }, {                                                                                                               // 1923
      $set: {                                                                                                          // 1923
        value: appAndPackageIds.map(function (data) {                                                                  // 1924
          return {                                                                                                     // 1925
            appId: data.appId,                                                                                         // 1926
            status: "notReady",                                                                                        // 1927
            packageId: data.packageId                                                                                  // 1928
          };                                                                                                           // 1925
        })                                                                                                             // 1930
      }                                                                                                                // 1923
    });                                                                                                                // 1923
    appAndPackageIds.forEach(function (data) {                                                                         // 1932
      _this5.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1933
    });                                                                                                                // 1934
  },                                                                                                                   // 1935
  getProductivitySuiteAppIds: function () {                                                                            // 1937
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1938
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1940
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1941
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1942
  },                                                                                                                   // 1944
  getSystemSuiteAppIds: function () {                                                                                  // 1946
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1947
  },                                                                                                                   // 1950
  isPreinstalledAppsReady: function () {                                                                               // 1952
    var setting = this.collections.settings.findOne({                                                                  // 1953
      _id: "preinstalledApps"                                                                                          // 1953
    });                                                                                                                // 1953
                                                                                                                       //
    if (!setting || !setting.value) {                                                                                  // 1954
      return true;                                                                                                     // 1955
    }                                                                                                                  // 1956
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1958
                                                                                                                       //
    var readyApps = this.collections.packages.find({                                                                   // 1959
      _id: {                                                                                                           // 1960
        $in: packageIds                                                                                                // 1961
      },                                                                                                               // 1960
      status: "ready"                                                                                                  // 1963
    });                                                                                                                // 1959
    return readyApps.count() === packageIds.length;                                                                    // 1965
  },                                                                                                                   // 1966
  getBillingPromptUrl: function () {                                                                                   // 1968
    var setting = this.collections.settings.findOne({                                                                  // 1969
      _id: "billingPromptUrl"                                                                                          // 1969
    });                                                                                                                // 1969
    return setting && setting.value;                                                                                   // 1970
  },                                                                                                                   // 1971
  isReferralEnabled: function () {                                                                                     // 1973
    // This function is a bit weird, in that we've transitioned from                                                   // 1974
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    // 1975
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  // 1976
    return Meteor.settings.public.quotaEnabled;                                                                        // 1977
  },                                                                                                                   // 1978
  isHideAboutEnabled: function () {                                                                                    // 1980
    var setting = this.collections.settings.findOne({                                                                  // 1981
      _id: "whiteLabelHideAbout"                                                                                       // 1981
    });                                                                                                                // 1981
    return setting && setting.value;                                                                                   // 1982
  },                                                                                                                   // 1983
  isQuotaEnabled: function () {                                                                                        // 1985
    if (Meteor.settings.public.quotaEnabled) return true;                                                              // 1986
    var setting = this.collections.settings.findOne({                                                                  // 1988
      _id: "quotaEnabled"                                                                                              // 1988
    });                                                                                                                // 1988
    return setting && setting.value;                                                                                   // 1989
  },                                                                                                                   // 1990
  isQuotaLdapEnabled: function () {                                                                                    // 1992
    var setting = this.collections.settings.findOne({                                                                  // 1993
      _id: "quotaLdapEnabled"                                                                                          // 1993
    });                                                                                                                // 1993
    return setting && setting.value;                                                                                   // 1994
  },                                                                                                                   // 1995
  updateUserQuota: function (user) {                                                                                   // 1997
    if (this.quotaManager) {                                                                                           // 1998
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1999
    }                                                                                                                  // 2000
  },                                                                                                                   // 2001
  getUserQuota: function (user) {                                                                                      // 2003
    if (this.isQuotaLdapEnabled()) {                                                                                   // 2004
      return this.quotaManager.updateUserQuota(this, user);                                                            // 2005
    } else {                                                                                                           // 2006
      var plan = this.getPlan(user.plan || "free", user);                                                              // 2007
      var referralBonus = calculateReferralBonus(user);                                                                // 2008
      var bonus = user.planBonus || {};                                                                                // 2009
      var userQuota = {                                                                                                // 2010
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 2011
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 2012
        compute: plan.compute + (bonus.compute || 0)                                                                   // 2013
      };                                                                                                               // 2010
      return userQuota;                                                                                                // 2015
    }                                                                                                                  // 2016
  },                                                                                                                   // 2017
  isUserOverQuota: function (user) {                                                                                   // 2019
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     // 2020
    // we will not allow the user to create new grains, though they may be able to open existing ones                  // 2021
    // which may still increase their storage usage.                                                                   // 2022
    //                                                                                                                 // 2023
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                // 2024
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 2026
    var plan = this.getUserQuota(user);                                                                                // 2028
                                                                                                                       //
    if (plan.grains < Infinity) {                                                                                      // 2029
      var count = this.collections.grains.find({                                                                       // 2030
        userId: user._id,                                                                                              // 2030
        trashed: {                                                                                                     // 2030
          $exists: false                                                                                               // 2030
        }                                                                                                              // 2030
      }, {                                                                                                             // 2030
        fields: {},                                                                                                    // 2031
        limit: plan.grains                                                                                             // 2031
      }).count();                                                                                                      // 2031
      if (count >= plan.grains) return "outOfGrains";                                                                  // 2032
    }                                                                                                                  // 2033
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 2035
  },                                                                                                                   // 2036
  isUserExcessivelyOverQuota: function (user) {                                                                        // 2038
    // Return true if user is so far over quota that we should prevent their existing grains from                      // 2039
    // running at all.                                                                                                 // 2040
    //                                                                                                                 // 2041
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                // 2042
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 2044
    var quota = this.getUserQuota(user); // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.
                                                                                                                       //
    if (quota.grains < Infinity) {                                                                                     // 2049
      var count = this.collections.grains.find({                                                                       // 2050
        userId: user._id,                                                                                              // 2050
        trashed: {                                                                                                     // 2050
          $exists: false                                                                                               // 2050
        }                                                                                                              // 2050
      }, {                                                                                                             // 2050
        fields: {},                                                                                                    // 2051
        limit: quota.grains * 2                                                                                        // 2051
      }).count();                                                                                                      // 2051
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 2052
    }                                                                                                                  // 2053
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 2055
  },                                                                                                                   // 2056
  suspendIdentity: function (userId, suspension) {                                                                     // 2058
    check(userId, String);                                                                                             // 2059
    check(suspension, {                                                                                                // 2060
      timestamp: Date,                                                                                                 // 2061
      admin: Match.Optional(String),                                                                                   // 2062
      voluntary: Match.Optional(Boolean)                                                                               // 2063
    });                                                                                                                // 2060
    this.collections.users.update({                                                                                    // 2066
      _id: userId                                                                                                      // 2066
    }, {                                                                                                               // 2066
      $set: {                                                                                                          // 2066
        suspended: suspension                                                                                          // 2066
      }                                                                                                                // 2066
    });                                                                                                                // 2066
    this.collections.apiTokens.update({                                                                                // 2067
      "owner.user.identityId": userId                                                                                  // 2067
    }, {                                                                                                               // 2067
      $set: {                                                                                                          // 2068
        suspended: true                                                                                                // 2068
      }                                                                                                                // 2068
    }, {                                                                                                               // 2068
      multi: true                                                                                                      // 2068
    });                                                                                                                // 2068
  },                                                                                                                   // 2069
  unsuspendIdentity: function (userId) {                                                                               // 2071
    check(userId, String);                                                                                             // 2072
    this.collections.users.update({                                                                                    // 2074
      _id: userId                                                                                                      // 2074
    }, {                                                                                                               // 2074
      $unset: {                                                                                                        // 2074
        suspended: 1                                                                                                   // 2074
      }                                                                                                                // 2074
    });                                                                                                                // 2074
    this.collections.apiTokens.update({                                                                                // 2075
      "owner.user.identityId": userId                                                                                  // 2075
    }, {                                                                                                               // 2075
      $unset: {                                                                                                        // 2076
        suspended: true                                                                                                // 2076
      }                                                                                                                // 2076
    }, {                                                                                                               // 2076
      multi: true                                                                                                      // 2076
    });                                                                                                                // 2076
  },                                                                                                                   // 2077
  suspendAccount: function (userId, byAdminUserId, willDelete) {                                                       // 2079
    var _this6 = this;                                                                                                 // 2079
                                                                                                                       //
    check(userId, String);                                                                                             // 2080
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 2081
    check(willDelete, Boolean);                                                                                        // 2082
    var user = this.collections.users.findOne({                                                                        // 2084
      _id: userId                                                                                                      // 2084
    });                                                                                                                // 2084
    var suspension = {                                                                                                 // 2085
      timestamp: new Date(),                                                                                           // 2086
      willDelete: willDelete || false                                                                                  // 2087
    };                                                                                                                 // 2085
                                                                                                                       //
    if (byAdminUserId) {                                                                                               // 2089
      suspension.admin = byAdminUserId;                                                                                // 2090
    } else {                                                                                                           // 2091
      suspension.voluntary = true;                                                                                     // 2092
    }                                                                                                                  // 2093
                                                                                                                       //
    this.collections.users.update({                                                                                    // 2095
      _id: userId                                                                                                      // 2095
    }, {                                                                                                               // 2095
      $set: {                                                                                                          // 2095
        suspended: suspension                                                                                          // 2095
      }                                                                                                                // 2095
    });                                                                                                                // 2095
    this.collections.grains.update({                                                                                   // 2096
      userId: userId                                                                                                   // 2096
    }, {                                                                                                               // 2096
      $set: {                                                                                                          // 2096
        suspended: true                                                                                                // 2096
      }                                                                                                                // 2096
    }, {                                                                                                               // 2096
      multi: true                                                                                                      // 2096
    });                                                                                                                // 2096
    delete suspension.willDelete; // Only mark the parent account for deletion. This makes the query simpler later.    // 2098
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2101
      _this6.suspendIdentity(identity.id, suspension);                                                                 // 2102
    });                                                                                                                // 2103
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2104
      if (_this6.collections.users.find({                                                                              // 2105
        $or: [{                                                                                                        // 2105
          "loginIdentities.id": identity.id                                                                            // 2106
        }, {                                                                                                           // 2106
          "nonloginIdentities.id": identity.id                                                                         // 2107
        }]                                                                                                             // 2107
      }).count() === 1) {                                                                                              // 2105
        // Only suspend non-login identities that are unique to this account.                                          // 2109
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2110
      }                                                                                                                // 2111
    }); // Force logout this user                                                                                      // 2112
                                                                                                                       //
    this.collections.users.update({                                                                                    // 2115
      _id: userId                                                                                                      // 2115
    }, {                                                                                                               // 2115
      $unset: {                                                                                                        // 2116
        "services.resume.loginTokens": 1                                                                               // 2116
      }                                                                                                                // 2116
    });                                                                                                                // 2116
                                                                                                                       //
    if (user && user.loginIdentities) {                                                                                // 2117
      user.loginIdentities.forEach(function (identity) {                                                               // 2118
        Meteor.users.update({                                                                                          // 2119
          _id: identity.id                                                                                             // 2119
        }, {                                                                                                           // 2119
          $unset: {                                                                                                    // 2119
            "services.resume.loginTokens": 1                                                                           // 2119
          }                                                                                                            // 2119
        });                                                                                                            // 2119
      });                                                                                                              // 2120
    }                                                                                                                  // 2121
  },                                                                                                                   // 2122
  unsuspendAccount: function (userId) {                                                                                // 2124
    var _this7 = this;                                                                                                 // 2124
                                                                                                                       //
    check(userId, String);                                                                                             // 2125
    var user = this.collections.users.findOne({                                                                        // 2127
      _id: userId                                                                                                      // 2127
    });                                                                                                                // 2127
    this.collections.users.update({                                                                                    // 2128
      _id: userId                                                                                                      // 2128
    }, {                                                                                                               // 2128
      $unset: {                                                                                                        // 2128
        suspended: 1                                                                                                   // 2128
      }                                                                                                                // 2128
    });                                                                                                                // 2128
    this.collections.grains.update({                                                                                   // 2129
      userId: userId                                                                                                   // 2129
    }, {                                                                                                               // 2129
      $unset: {                                                                                                        // 2129
        suspended: 1                                                                                                   // 2129
      }                                                                                                                // 2129
    }, {                                                                                                               // 2129
      multi: true                                                                                                      // 2129
    });                                                                                                                // 2129
    user.loginIdentities.forEach(function (identity) {                                                                 // 2131
      _this7.unsuspendIdentity(identity.id);                                                                           // 2132
    });                                                                                                                // 2133
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2135
      _this7.unsuspendIdentity(identity.id);                                                                           // 2136
    });                                                                                                                // 2137
  },                                                                                                                   // 2138
  deletePendingAccounts: function (deletionCoolingOffTime, backend, cb) {                                              // 2140
    var _this8 = this;                                                                                                 // 2140
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2141
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2143
    this.collections.users.find({                                                                                      // 2144
      "suspended.willDelete": true,                                                                                    // 2145
      "suspended.timestamp": {                                                                                         // 2146
        $lt: queryDate                                                                                                 // 2146
      }                                                                                                                // 2146
    }).forEach(function (user) {                                                                                       // 2144
      if (cb) cb(_this8, user);                                                                                        // 2148
                                                                                                                       //
      _this8.deleteAccount(user._id, backend);                                                                         // 2149
    });                                                                                                                // 2150
  },                                                                                                                   // 2151
  hostIsStandalone: function (hostname) {                                                                              // 2153
    check(hostname, String);                                                                                           // 2154
    return !!this.collections.standaloneDomains.findOne({                                                              // 2156
      _id: hostname                                                                                                    // 2156
    });                                                                                                                // 2156
  }                                                                                                                    // 2157
});                                                                                                                    // 1250
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2160
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     // 2161
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   // 2162
  // and seems to be a de facto standard, for example:                                                                 // 2163
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  // 2164
  return key.replace(".", "\uFF0E").replace("$", "\uFF04");                                                            // 2165
};                                                                                                                     // 2166
                                                                                                                       //
var appNameFromPackage = function (packageObj) {                                                                       // 2168
  // This function takes a Package object from Mongo and returns an                                                    // 2169
  // app title.                                                                                                        // 2170
  var manifest = packageObj.manifest;                                                                                  // 2171
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2172
  var action = manifest.actions[0];                                                                                    // 2173
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2174
  return appName;                                                                                                      // 2176
};                                                                                                                     // 2177
                                                                                                                       //
var appNameFromActionName = function (name) {                                                                          // 2179
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               // 2180
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  // 2181
  //   derive the app title from the action title.                                                                     // 2182
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        // 2183
  if (!name) {                                                                                                         // 2184
    return "(unnamed)";                                                                                                // 2185
  }                                                                                                                    // 2186
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2188
    name = name.slice(4);                                                                                              // 2189
  }                                                                                                                    // 2190
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2192
    name = "Hacker CMS";                                                                                               // 2193
  } else {                                                                                                             // 2194
    var space = name.indexOf(" ");                                                                                     // 2195
                                                                                                                       //
    if (space > 0) {                                                                                                   // 2196
      name = name.slice(0, space);                                                                                     // 2197
    }                                                                                                                  // 2198
  }                                                                                                                    // 2199
                                                                                                                       //
  return name;                                                                                                         // 2201
};                                                                                                                     // 2202
                                                                                                                       //
var appShortDescriptionFromPackage = function (pkg) {                                                                  // 2204
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2208
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function (action, appTitle) {                                                     // 2210
  // A hack to deal with legacy apps not including fields in their manifests.                                          // 2211
  // I look forward to the day I can remove most of this code.                                                         // 2212
  // Attempt to figure out the appropriate noun that this action will create.                                          // 2213
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            // 2214
  if (action.nounPhrase) return action.nounPhrase.defaultText; // Otherwise, try to guess one from the structure of the action title field
                                                                                                                       //
  if (action.title && action.title.defaultText) {                                                                      // 2217
    var text = action.title.defaultText; // Strip a leading "New "                                                     // 2218
                                                                                                                       //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2220
      var candidate = text.slice(4); // Strip a leading appname too, if provided                                       // 2221
                                                                                                                       //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2223
        var newCandidate = candidate.slice(appTitle.length); // Unless that leaves you with no noun, in which case, use "grain"
                                                                                                                       //
        if (newCandidate.length > 0) {                                                                                 // 2226
          return newCandidate.toLowerCase();                                                                           // 2227
        } else {                                                                                                       // 2228
          return "grain";                                                                                              // 2229
        }                                                                                                              // 2230
      }                                                                                                                // 2231
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2233
    } // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                      // 2234
    // the package soon.                                                                                               // 2236
                                                                                                                       //
                                                                                                                       //
    return text;                                                                                                       // 2237
  } else {                                                                                                             // 2238
    return "grain";                                                                                                    // 2239
  }                                                                                                                    // 2240
}; // Static methods on SandstormDb that don't need an instance.                                                       // 2241
// Largely things that deal with backwards-compatibility.                                                              // 2244
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb, {                                                                                                // 2245
  appNameFromActionName: appNameFromActionName,                                                                        // 2246
  appNameFromPackage: appNameFromPackage,                                                                              // 2247
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2248
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2249
});                                                                                                                    // 2245
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2252
  var _Crypto2 = Npm.require("crypto");                                                                                // 2253
                                                                                                                       //
  var ContentType = Npm.require("content-type");                                                                       // 2254
                                                                                                                       //
  var Zlib = Npm.require("zlib");                                                                                      // 2255
                                                                                                                       //
  var _Url2 = Npm.require("url");                                                                                      // 2256
                                                                                                                       //
  var replicaNumber = Meteor.settings.replicaNumber || 0;                                                              // 2258
                                                                                                                       //
  var computeStagger = function (n) {                                                                                  // 2260
    // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                          // 2261
    // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                           // 2262
    // The sequence looks like:                                                                                        // 2263
    //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                               // 2264
    //                                                                                                                 // 2265
    // We use this to determine how we'll stagger periodic events performed by this replica.                           // 2266
    // Notice that this allows us to compute a stagger which is independent of the number of                           // 2267
    // front-end replicas present; we can add more replicas to the end without affecting how the                       // 2268
    // earlier ones schedule their events.                                                                             // 2269
    var denom = 1;                                                                                                     // 2270
                                                                                                                       //
    while (denom <= n) {                                                                                               // 2271
      denom <<= 1;                                                                                                     // 2271
    }                                                                                                                  // 2271
                                                                                                                       //
    var num = n * 2 - denom + 1;                                                                                       // 2272
    return num / denom;                                                                                                // 2273
  };                                                                                                                   // 2274
                                                                                                                       //
  var stagger = computeStagger(replicaNumber);                                                                         // 2276
                                                                                                                       //
  SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                      // 2278
    // Register a database cleanup function than should run periodically, roughly once every                           // 2279
    // interval of the given length.                                                                                   // 2280
    //                                                                                                                 // 2281
    // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                        // 2282
    // scaled appropriately on the assumption that more data is being generated demanding more                         // 2283
    // frequent cleanups.                                                                                              // 2284
    check(intervalMs, Number);                                                                                         // 2286
    check(callback, Function);                                                                                         // 2287
                                                                                                                       //
    if (intervalMs < 120000) {                                                                                         // 2289
      throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");      // 2290
    } // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      // 2292
    // the schedule is independent of the exact startup time.                                                          // 2295
                                                                                                                       //
                                                                                                                       //
    var first = intervalMs - Date.now() % intervalMs; // Stagger cleanups across replicas so that we don't have all replicas trying to clean the
    // same data at the same time.                                                                                     // 2299
                                                                                                                       //
    first += Math.floor(intervalMs * computeStagger(replicaNumber)); // If the stagger put us more than an interval away from now, back up.
                                                                                                                       //
    if (first > intervalMs) first -= intervalMs;                                                                       // 2303
    Meteor.setTimeout(function () {                                                                                    // 2305
      callback();                                                                                                      // 2306
      Meteor.setInterval(callback, intervalMs);                                                                        // 2307
    }, first);                                                                                                         // 2308
  }; // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                         // 2309
                                                                                                                       //
                                                                                                                       //
  var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                    // 2312
                                                                                                                       //
  var BufferSmallerThan = function (limit) {                                                                           // 2314
    return Match.Where(function (buf) {                                                                                // 2315
      check(buf, Buffer);                                                                                              // 2316
      return buf.length < limit;                                                                                       // 2317
    });                                                                                                                // 2318
  };                                                                                                                   // 2319
                                                                                                                       //
  var DatabaseId = Match.Where(function (s) {                                                                          // 2321
    check(s, String);                                                                                                  // 2322
    return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                               // 2323
  });                                                                                                                  // 2324
                                                                                                                       //
  SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                                // 2326
    // Add a new static asset to the database. If `content` is a string rather than a buffer, it                       // 2327
    // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                    // 2328
    if (typeof content === "string" && !metadata.encoding) {                                                           // 2330
      content = gzipSync(new Buffer(content, "utf8"));                                                                 // 2331
      metadata.encoding = "gzip";                                                                                      // 2332
    }                                                                                                                  // 2333
                                                                                                                       //
    check(metadata, {                                                                                                  // 2335
      mimeType: String,                                                                                                // 2336
      encoding: Match.Optional("gzip")                                                                                 // 2337
    });                                                                                                                // 2335
    check(content, BufferSmallerThan(1 << 20)); // Validate content type.                                              // 2339
                                                                                                                       //
    metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                      // 2342
                                                                                                                       //
    var hasher = _Crypto2.createHash("sha256");                                                                        // 2344
                                                                                                                       //
    hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                        // 2345
    hasher.update(content);                                                                                            // 2346
    var hash = hasher.digest("base64");                                                                                // 2347
    var result = this.collections.staticAssets.findAndModify({                                                         // 2349
      query: {                                                                                                         // 2350
        hash: hash,                                                                                                    // 2350
        refcount: {                                                                                                    // 2350
          $gte: 1                                                                                                      // 2350
        }                                                                                                              // 2350
      },                                                                                                               // 2350
      update: {                                                                                                        // 2351
        $inc: {                                                                                                        // 2351
          refcount: 1                                                                                                  // 2351
        }                                                                                                              // 2351
      },                                                                                                               // 2351
      fields: {                                                                                                        // 2352
        _id: 1,                                                                                                        // 2352
        refcount: 1                                                                                                    // 2352
      }                                                                                                                // 2352
    });                                                                                                                // 2349
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2355
      throw new Error("Couldn't increment refcount of asset with hash " + hash);                                       // 2356
    }                                                                                                                  // 2357
                                                                                                                       //
    var existing = result.value;                                                                                       // 2359
                                                                                                                       //
    if (existing) {                                                                                                    // 2360
      return existing._id;                                                                                             // 2361
    }                                                                                                                  // 2362
                                                                                                                       //
    return this.collections.staticAssets.insert(_.extend({                                                             // 2364
      hash: hash,                                                                                                      // 2365
      content: content,                                                                                                // 2366
      refcount: 1                                                                                                      // 2367
    }, metadata));                                                                                                     // 2364
  };                                                                                                                   // 2369
                                                                                                                       //
  SandstormDb.prototype.refStaticAsset = function (id) {                                                               // 2371
    // Increment the refcount on an existing static asset. Returns the asset on success.                               // 2372
    // If the asset does not exist, returns a falsey value.                                                            // 2373
    //                                                                                                                 // 2374
    // You must call this BEFORE adding the new reference to the DB, in case of failure between                        // 2375
    // the two calls. (This way, the failure case is a storage leak, which is probably not a big                       // 2376
    // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                         // 2377
    check(id, String);                                                                                                 // 2379
    var result = this.collections.staticAssets.findAndModify({                                                         // 2381
      query: {                                                                                                         // 2382
        hash: hash                                                                                                     // 2382
      },                                                                                                               // 2382
      update: {                                                                                                        // 2383
        $inc: {                                                                                                        // 2383
          refcount: 1                                                                                                  // 2383
        }                                                                                                              // 2383
      },                                                                                                               // 2383
      fields: {                                                                                                        // 2384
        _id: 1,                                                                                                        // 2384
        content: 1,                                                                                                    // 2384
        mimeType: 1                                                                                                    // 2384
      }                                                                                                                // 2384
    });                                                                                                                // 2381
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2387
      throw new Error("Couldn't increment refcount of asset with hash " + hash);                                       // 2388
    }                                                                                                                  // 2389
                                                                                                                       //
    var existing = result.value;                                                                                       // 2391
    return existing;                                                                                                   // 2392
  };                                                                                                                   // 2393
                                                                                                                       //
  SandstormDb.prototype.unrefStaticAsset = function (id) {                                                             // 2395
    // Decrement refcount on a static asset and delete if it has reached zero.                                         // 2396
    //                                                                                                                 // 2397
    // You must call this AFTER removing the reference from the DB, in case of failure between                         // 2398
    // the two calls. (This way, the failure case is a storage leak, which is probably not a big                       // 2399
    // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                         // 2400
    check(id, String);                                                                                                 // 2402
    var result = this.collections.staticAssets.findAndModify({                                                         // 2404
      query: {                                                                                                         // 2405
        _id: id                                                                                                        // 2405
      },                                                                                                               // 2405
      update: {                                                                                                        // 2406
        $inc: {                                                                                                        // 2406
          refcount: -1                                                                                                 // 2406
        }                                                                                                              // 2406
      },                                                                                                               // 2406
      fields: {                                                                                                        // 2407
        _id: 1,                                                                                                        // 2407
        refcount: 1                                                                                                    // 2407
      },                                                                                                               // 2407
      "new": true                                                                                                      // 2408
    });                                                                                                                // 2404
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2411
      throw new Error("Couldn't unref static asset " + id);                                                            // 2412
    }                                                                                                                  // 2413
                                                                                                                       //
    var existing = result.value;                                                                                       // 2415
                                                                                                                       //
    if (!existing) {                                                                                                   // 2416
      console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                         // 2417
    } else if (existing.refcount <= 0) {                                                                               // 2418
      this.collections.staticAssets.remove({                                                                           // 2419
        _id: existing._id                                                                                              // 2419
      });                                                                                                              // 2419
    }                                                                                                                  // 2420
  };                                                                                                                   // 2421
                                                                                                                       //
  SandstormDb.prototype.getStaticAsset = function (id) {                                                               // 2423
    // Get a static asset's mimeType, encoding, and raw content.                                                       // 2424
    check(id, String);                                                                                                 // 2426
    var asset = this.collections.staticAssets.findOne(id, {                                                            // 2428
      fields: {                                                                                                        // 2428
        _id: 0,                                                                                                        // 2428
        mimeType: 1,                                                                                                   // 2428
        encoding: 1,                                                                                                   // 2428
        content: 1                                                                                                     // 2428
      }                                                                                                                // 2428
    });                                                                                                                // 2428
                                                                                                                       //
    if (asset) {                                                                                                       // 2429
      // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                        // 2430
      //   here.                                                                                                       // 2431
      asset.content = new Buffer(asset.content);                                                                       // 2432
    }                                                                                                                  // 2433
                                                                                                                       //
    return asset;                                                                                                      // 2435
  };                                                                                                                   // 2436
                                                                                                                       //
  SandstormDb.prototype.newAssetUpload = function (purpose) {                                                          // 2438
    check(purpose, Match.OneOf({                                                                                       // 2439
      profilePicture: {                                                                                                // 2440
        userId: DatabaseId,                                                                                            // 2440
        identityId: DatabaseId                                                                                         // 2440
      }                                                                                                                // 2440
    }, {                                                                                                               // 2440
      loginLogo: {}                                                                                                    // 2441
    }));                                                                                                               // 2441
    return this.collections.assetUploadTokens.insert({                                                                 // 2444
      purpose: purpose,                                                                                                // 2445
      expires: new Date(Date.now() + 300000)                                                                           // 2446
    });                                                                                                                // 2444
  };                                                                                                                   // 2448
                                                                                                                       //
  SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                           // 2450
    // Indicates that the given asset upload has completed. It will be removed and its purpose                         // 2451
    // returned. If no matching upload exists, returns undefined.                                                      // 2452
    check(id, String);                                                                                                 // 2454
    var result = this.collections.assetUploadTokens.findAndModify({                                                    // 2456
      query: {                                                                                                         // 2457
        _id: id                                                                                                        // 2457
      },                                                                                                               // 2457
      remove: true                                                                                                     // 2458
    });                                                                                                                // 2456
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2461
      throw new Error("Failed to remove asset upload token");                                                          // 2462
    }                                                                                                                  // 2463
                                                                                                                       //
    var upload = result.value;                                                                                         // 2465
                                                                                                                       //
    if (upload.expires.valueOf() < Date.now()) {                                                                       // 2467
      return undefined; // already expired                                                                             // 2468
    } else {                                                                                                           // 2469
      return upload.purpose;                                                                                           // 2470
    }                                                                                                                  // 2471
  };                                                                                                                   // 2472
                                                                                                                       //
  SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                     // 2474
    this.collections.assetUploadTokens.remove({                                                                        // 2475
      expires: {                                                                                                       // 2475
        $lt: Date.now()                                                                                                // 2475
      }                                                                                                                // 2475
    });                                                                                                                // 2475
  }; // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                  // 2476
                                                                                                                       //
                                                                                                                       //
  var Future = Npm.require("fibers/future");                                                                           // 2479
                                                                                                                       //
  var promiseToFuture = function (promise) {                                                                           // 2480
    var result = new Future();                                                                                         // 2481
    promise.then(result.return.bind(result), result.throw.bind(result));                                               // 2482
    return result;                                                                                                     // 2483
  };                                                                                                                   // 2484
                                                                                                                       //
  var waitPromise = function (promise) {                                                                               // 2486
    return promiseToFuture(promise).wait();                                                                            // 2487
  };                                                                                                                   // 2488
                                                                                                                       //
  SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                               // 2490
    var _this9 = this;                                                                                                 // 2490
                                                                                                                       //
    // Returns the number of grains deleted.                                                                           // 2491
    check(type, Match.OneOf("grain", "demoGrain"));                                                                    // 2493
    var numDeleted = 0;                                                                                                // 2495
    this.collections.grains.find(query).forEach(function (grain) {                                                     // 2496
      var user = Meteor.users.findOne(grain.userId);                                                                   // 2497
      waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                       // 2499
      numDeleted += _this9.collections.grains.remove({                                                                 // 2500
        _id: grain._id                                                                                                 // 2500
      });                                                                                                              // 2500
                                                                                                                       //
      _this9.removeApiTokens({                                                                                         // 2501
        grainId: grain._id,                                                                                            // 2502
        $or: [{                                                                                                        // 2503
          owner: {                                                                                                     // 2504
            $exists: false                                                                                             // 2504
          }                                                                                                            // 2504
        }, {                                                                                                           // 2504
          owner: {                                                                                                     // 2505
            webkey: null                                                                                               // 2505
          }                                                                                                            // 2505
        }]                                                                                                             // 2505
      });                                                                                                              // 2501
                                                                                                                       //
      _this9.removeApiTokens({                                                                                         // 2509
        "owner.grain.grainId": grain._id                                                                               // 2509
      });                                                                                                              // 2509
                                                                                                                       //
      _this9.collections.activitySubscriptions.remove({                                                                // 2511
        grainId: grain._id                                                                                             // 2511
      });                                                                                                              // 2511
                                                                                                                       //
      if (grain.lastUsed) {                                                                                            // 2513
        var record = {                                                                                                 // 2514
          type: "grain",                                                                                               // 2515
          // Demo grains can never get here!                                                                           // 2515
          lastActive: grain.lastUsed,                                                                                  // 2516
          appId: grain.appId                                                                                           // 2517
        };                                                                                                             // 2514
                                                                                                                       //
        if (user && user.experiments) {                                                                                // 2519
          record.experiments = user.experiments;                                                                       // 2520
        }                                                                                                              // 2521
                                                                                                                       //
        _this9.collections.deleteStats.insert(record);                                                                 // 2523
      }                                                                                                                // 2524
                                                                                                                       //
      _this9.deleteUnusedPackages(grain.appId);                                                                        // 2526
                                                                                                                       //
      if (grain.size) {                                                                                                // 2528
        Meteor.users.update(grain.userId, {                                                                            // 2529
          $inc: {                                                                                                      // 2529
            storageUsage: -grain.size                                                                                  // 2529
          }                                                                                                            // 2529
        });                                                                                                            // 2529
      }                                                                                                                // 2530
    });                                                                                                                // 2531
    return numDeleted;                                                                                                 // 2532
  };                                                                                                                   // 2533
                                                                                                                       //
  SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                   // 2535
    check(grainId, String);                                                                                            // 2536
    check(accountId, Match.OneOf(String, undefined, null));                                                            // 2537
    check(identityId, String);                                                                                         // 2538
    var grain = this.getGrain(grainId);                                                                                // 2540
                                                                                                                       //
    if (!grain) {                                                                                                      // 2541
      throw new Error("called userGrainTitle() for a grain that doesn't exist");                                       // 2542
    }                                                                                                                  // 2543
                                                                                                                       //
    var title = grain.title;                                                                                           // 2545
                                                                                                                       //
    if (grain.userId !== accountId) {                                                                                  // 2546
      var sharerToken = this.collections.apiTokens.findOne({                                                           // 2547
        grainId: grainId,                                                                                              // 2548
        "owner.user.identityId": identityId                                                                            // 2549
      }, {                                                                                                             // 2547
        sort: {                                                                                                        // 2551
          lastUsed: -1                                                                                                 // 2552
        }                                                                                                              // 2551
      });                                                                                                              // 2550
                                                                                                                       //
      if (sharerToken) {                                                                                               // 2555
        title = sharerToken.owner.user.title;                                                                          // 2556
      } else {                                                                                                         // 2557
        title = "shared grain";                                                                                        // 2558
      }                                                                                                                // 2559
    }                                                                                                                  // 2560
                                                                                                                       //
    return title;                                                                                                      // 2562
  };                                                                                                                   // 2563
                                                                                                                       //
  var packageCache = {}; // Package info is immutable. Let's cache to save on mongo queries.                           // 2565
                                                                                                                       //
  SandstormDb.prototype.getPackage = function (packageId) {                                                            // 2568
    // Get the given package record. Since package info is immutable, cache the data in the server                     // 2569
    // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                         // 2570
    // lot.                                                                                                            // 2571
    if (packageId in packageCache) {                                                                                   // 2573
      return packageCache[packageId];                                                                                  // 2574
    }                                                                                                                  // 2575
                                                                                                                       //
    var pkg = this.collections.packages.findOne(packageId);                                                            // 2577
                                                                                                                       //
    if (pkg && pkg.status === "ready") {                                                                               // 2578
      packageCache[packageId] = pkg;                                                                                   // 2579
    }                                                                                                                  // 2580
                                                                                                                       //
    return pkg;                                                                                                        // 2582
  };                                                                                                                   // 2583
                                                                                                                       //
  SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                      // 2585
    var _this10 = this;                                                                                                // 2585
                                                                                                                       //
    check(appId, String);                                                                                              // 2586
    this.collections.packages.find({                                                                                   // 2587
      appId: appId                                                                                                     // 2587
    }).forEach(function (pkg) {                                                                                        // 2587
      // Mark package for possible deletion;                                                                           // 2588
      _this10.collections.packages.update({                                                                            // 2589
        _id: pkg._id,                                                                                                  // 2589
        status: "ready"                                                                                                // 2589
      }, {                                                                                                             // 2589
        $set: {                                                                                                        // 2589
          shouldCleanup: true                                                                                          // 2589
        }                                                                                                              // 2589
      });                                                                                                              // 2589
    });                                                                                                                // 2590
  };                                                                                                                   // 2591
                                                                                                                       //
  SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
    var _this11 = this;                                                                                                // 2594
                                                                                                                       //
    var actions = this.collections.userActions.find({                                                                  // 2595
      appId: appId,                                                                                                    // 2595
      appVersion: {                                                                                                    // 2595
        $lt: versionNumber                                                                                             // 2595
      }                                                                                                                // 2595
    }, {                                                                                                               // 2595
      fields: {                                                                                                        // 2596
        userId: 1                                                                                                      // 2596
      }                                                                                                                // 2596
    });                                                                                                                // 2596
    actions.forEach(function (action) {                                                                                // 2597
      var userId = action.userId;                                                                                      // 2598
      var updater = {                                                                                                  // 2599
        timestamp: new Date(),                                                                                         // 2600
        isUnread: true                                                                                                 // 2601
      };                                                                                                               // 2599
                                                                                                                       //
      var inserter = _.extend({                                                                                        // 2603
        userId: userId,                                                                                                // 2603
        appUpdates: {}                                                                                                 // 2603
      }, updater); // Set only the appId that we care about. Use mongo's dot notation to specify only a single         // 2603
      // field inside of an object to update                                                                           // 2606
                                                                                                                       //
                                                                                                                       //
      inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                  // 2607
        marketingVersion: marketingVersion,                                                                            // 2608
        packageId: packageId,                                                                                          // 2609
        name: name,                                                                                                    // 2610
        version: versionNumber                                                                                         // 2611
      }; // We unfortunately cannot upsert because upserts can only have field equality conditions in                  // 2607
      // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                         // 2615
                                                                                                                       //
      if (_this11.collections.notifications.update({                                                                   // 2616
        userId: userId,                                                                                                // 2617
        appUpdates: {                                                                                                  // 2617
          $exists: true                                                                                                // 2617
        }                                                                                                              // 2617
      }, {                                                                                                             // 2617
        $set: updater                                                                                                  // 2618
      }) == 0) {                                                                                                       // 2618
        // Update failed; try an insert instead.                                                                       // 2619
        _this11.collections.notifications.insert(inserter);                                                            // 2620
      }                                                                                                                // 2621
    });                                                                                                                // 2622
    this.collections.appIndex.update({                                                                                 // 2624
      _id: appId                                                                                                       // 2624
    }, {                                                                                                               // 2624
      $set: {                                                                                                          // 2624
        hasSentNotifications: true                                                                                     // 2624
      }                                                                                                                // 2624
    }); // In the case where we replaced a previous notification and that was the only reference to the                // 2624
    // package, we need to clean it up                                                                                 // 2627
                                                                                                                       //
    this.deleteUnusedPackages(appId);                                                                                  // 2628
  };                                                                                                                   // 2629
                                                                                                                       //
  SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                          // 2631
    this.collections.notifications.upsert({                                                                            // 2632
      userId: userId,                                                                                                  // 2633
      referral: true                                                                                                   // 2634
    }, {                                                                                                               // 2632
      userId: userId,                                                                                                  // 2636
      referral: true,                                                                                                  // 2637
      timestamp: new Date(),                                                                                           // 2638
      isUnread: true                                                                                                   // 2639
    });                                                                                                                // 2635
  };                                                                                                                   // 2641
                                                                                                                       //
  SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                                // 2643
    check(appId, String);                                                                                              // 2644
    check(version, Match.Integer);                                                                                     // 2645
    check(packageId, String);                                                                                          // 2646
    var selector = {                                                                                                   // 2648
      userId: Meteor.userId(),                                                                                         // 2649
      appId: appId,                                                                                                    // 2650
      appVersion: {                                                                                                    // 2651
        $lte: version                                                                                                  // 2651
      },                                                                                                               // 2651
      packageId: {                                                                                                     // 2652
        $ne: packageId                                                                                                 // 2652
      }                                                                                                                // 2652
    };                                                                                                                 // 2648
    this.collections.grains.find(selector).forEach(function (grain) {                                                  // 2655
      backend.shutdownGrain(grain._id, grain.userId);                                                                  // 2656
    });                                                                                                                // 2657
    this.collections.grains.update(selector, {                                                                         // 2659
      $set: {                                                                                                          // 2660
        appVersion: version,                                                                                           // 2660
        packageId: packageId,                                                                                          // 2660
        packageSalt: Random.secret()                                                                                   // 2660
      }                                                                                                                // 2660
    }, {                                                                                                               // 2659
      multi: true                                                                                                      // 2661
    });                                                                                                                // 2661
  };                                                                                                                   // 2662
                                                                                                                       //
  SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                         // 2664
    // Mark package for possible installation.                                                                         // 2665
    var fields = {                                                                                                     // 2667
      status: "download",                                                                                              // 2668
      progress: 0,                                                                                                     // 2669
      url: url,                                                                                                        // 2670
      isAutoUpdated: !!isAutoUpdated                                                                                   // 2671
    };                                                                                                                 // 2667
                                                                                                                       //
    if (retryFailed) {                                                                                                 // 2674
      this.collections.packages.update({                                                                               // 2675
        _id: packageId,                                                                                                // 2675
        status: "failed"                                                                                               // 2675
      }, {                                                                                                             // 2675
        $set: fields                                                                                                   // 2675
      });                                                                                                              // 2675
    } else {                                                                                                           // 2676
      try {                                                                                                            // 2677
        fields._id = packageId;                                                                                        // 2678
        this.collections.packages.insert(fields);                                                                      // 2679
      } catch (err) {                                                                                                  // 2680
        console.error("Simultaneous startInstall()s?", err.stack);                                                     // 2681
      }                                                                                                                // 2682
    }                                                                                                                  // 2683
  };                                                                                                                   // 2684
                                                                                                                       //
  var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                    // 2686
    check(keyFingerprint, String);                                                                                     // 2687
    return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                   // 2688
  });                                                                                                                  // 2689
                                                                                                                       //
  SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                        // 2691
    var _this12 = this;                                                                                                // 2691
                                                                                                                       //
    // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                     // 2692
    check(keyFingerprint, ValidKeyFingerprint);                                                                        // 2694
    console.log("fetching keybase", keyFingerprint);                                                                   // 2696
    HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
      timeout: 5000                                                                                                    // 2701
    }, function (err, keybaseResponse) {                                                                               // 2700
      if (err) {                                                                                                       // 2703
        console.log("keybase lookup error:", err.stack);                                                               // 2704
        return;                                                                                                        // 2705
      }                                                                                                                // 2706
                                                                                                                       //
      if (!keybaseResponse.data) {                                                                                     // 2708
        console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                  // 2709
        return;                                                                                                        // 2710
      }                                                                                                                // 2711
                                                                                                                       //
      var profile = (keybaseResponse.data.them || [])[0];                                                              // 2713
                                                                                                                       //
      if (profile) {                                                                                                   // 2715
        // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                         // 2716
        var record = {                                                                                                 // 2717
          displayName: (profile.profile || {}).full_name,                                                              // 2718
          handle: (profile.basics || {}).username,                                                                     // 2719
          proofs: (profile.proofs_summary || {}).all || []                                                             // 2720
        }; // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                       // 2717
                                                                                                                       //
        record.proofs.forEach(function (proof) {                                                                       // 2724
          // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                      // 2725
          // this would filter.)                                                                                       // 2726
          for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                           // 2727
            // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                      // 2728
            // because I'm too lazy to check the field names recursively (and Keybase doesn't                          // 2729
            // return any objects anyway).                                                                             // 2730
            if (field.match(/[.$]/) || (0, _typeof3.default)(proof[field]) === "object") {                             // 2731
              delete proof[field];                                                                                     // 2732
            }                                                                                                          // 2733
          } // Indicate not verified.                                                                                  // 2734
          // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                      // 2737
          //   Keybase node-based CLI.                                                                                 // 2738
                                                                                                                       //
                                                                                                                       //
          proof.status = "unverified";                                                                                 // 2739
        });                                                                                                            // 2740
                                                                                                                       //
        _this12.collections.keybaseProfiles.update(keyFingerprint, {                                                   // 2742
          $set: record                                                                                                 // 2742
        }, {                                                                                                           // 2742
          upsert: true                                                                                                 // 2742
        });                                                                                                            // 2742
      } else {                                                                                                         // 2743
        // Keybase reports no match, so remove what we know of this user. We don't want to remove                      // 2744
        // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                      // 2745
        // from Keybase.                                                                                               // 2746
        //                                                                                                             // 2747
        // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                       // 2748
        //   but at present we don't have the ability to verify proofs.                                                // 2749
        _this12.collections.keybaseProfiles.update(keyFingerprint, {                                                   // 2750
          $unset: {                                                                                                    // 2751
            displayName: "",                                                                                           // 2751
            handle: "",                                                                                                // 2751
            proofs: ""                                                                                                 // 2751
          }                                                                                                            // 2751
        }, {                                                                                                           // 2751
          upsert: true                                                                                                 // 2751
        });                                                                                                            // 2751
      }                                                                                                                // 2752
    });                                                                                                                // 2753
  };                                                                                                                   // 2754
                                                                                                                       //
  SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                         // 2756
    // If there is an *unused* account that has `identityId` as a login identity, deletes it.                          // 2757
    check(identityId, String);                                                                                         // 2759
    var account = this.collections.users.findOne({                                                                     // 2760
      "loginIdentities.id": identityId                                                                                 // 2760
    });                                                                                                                // 2760
                                                                                                                       //
    if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({
      userId: account._id                                                                                              // 2764
    }) && !this.collections.apiTokens.findOne({                                                                        // 2764
      accountId: account._id                                                                                           // 2765
    }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({
      ownerId: account._id                                                                                             // 2768
    })) {                                                                                                              // 2768
      this.collections.users.remove({                                                                                  // 2769
        _id: account._id                                                                                               // 2769
      });                                                                                                              // 2769
      backend.deleteUser(account._id);                                                                                 // 2770
    }                                                                                                                  // 2771
  };                                                                                                                   // 2772
                                                                                                                       //
  Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                         // 2774
    check(keyFingerprint, ValidKeyFingerprint);                                                                        // 2775
    var db = this.connection.sandstormDb;                                                                              // 2776
    var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                  // 2778
                                                                                                                       //
    if (cursor.count() === 0) {                                                                                        // 2779
      // Fire off async update.                                                                                        // 2780
      db.updateKeybaseProfileAsync(keyFingerprint);                                                                    // 2781
    }                                                                                                                  // 2782
                                                                                                                       //
    return cursor;                                                                                                     // 2784
  });                                                                                                                  // 2785
  Meteor.publish("appIndex", function (appId) {                                                                        // 2787
    check(appId, String);                                                                                              // 2788
    var db = this.connection.sandstormDb;                                                                              // 2789
    var cursor = db.collections.appIndex.find({                                                                        // 2790
      _id: appId                                                                                                       // 2790
    });                                                                                                                // 2790
    return cursor;                                                                                                     // 2791
  });                                                                                                                  // 2792
  Meteor.publish("userPackages", function () {                                                                         // 2794
    var _this13 = this;                                                                                                // 2794
                                                                                                                       //
    // Users should be able to see packages that are either:                                                           // 2795
    // 1. referenced by one of their userActions                                                                       // 2796
    // 2. referenced by one of their grains                                                                            // 2797
    var db = this.connection.sandstormDb; // Note that package information, once it is in the database, is static. There's no need to
    // reactively subscribe to changes to a package since they don't change. It's also unecessary                      // 2801
    // to reactively remove a package from the client side when it is removed on the server, or                        // 2802
    // when the client stops using it, because the worst case is the client has a small amount                         // 2803
    // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                          // 2804
    // So, we implement this as a cache: the first time each package ID shows up among the user's                      // 2805
    // stuff, we push the package info to the client, and then we never update it.                                     // 2806
    //                                                                                                                 // 2807
    // Alternatively, we could subscribe to each individual package query, but this would waste                        // 2808
    // lots of server-side resources watching for events that will never happen or don't matter.                       // 2809
                                                                                                                       //
    var hasPackage = {};                                                                                               // 2810
                                                                                                                       //
    var refPackage = function (packageId) {                                                                            // 2811
      // Ignore dev apps.                                                                                              // 2812
      if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                              // 2813
                                                                                                                       //
      if (!hasPackage[packageId]) {                                                                                    // 2815
        hasPackage[packageId] = true;                                                                                  // 2816
        var pkg = db.getPackage(packageId);                                                                            // 2817
                                                                                                                       //
        if (pkg) {                                                                                                     // 2818
          _this13.added("packages", packageId, pkg);                                                                   // 2819
        } else {                                                                                                       // 2820
          console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                   // 2821
        }                                                                                                              // 2823
      }                                                                                                                // 2824
    }; // package source 1: packages referred to by actions                                                            // 2825
                                                                                                                       //
                                                                                                                       //
    var actions = db.userActions(this.userId);                                                                         // 2828
    var actionsHandle = actions.observe({                                                                              // 2829
      added: function (newAction) {                                                                                    // 2830
        refPackage(newAction.packageId);                                                                               // 2831
      },                                                                                                               // 2832
      changed: function (newAction, oldAction) {                                                                       // 2834
        refPackage(newAction.packageId);                                                                               // 2835
      }                                                                                                                // 2836
    }); // package source 2: packages referred to by grains directly                                                   // 2829
                                                                                                                       //
    var grains = db.userGrains(this.userId, {                                                                          // 2840
      includeTrash: true                                                                                               // 2840
    });                                                                                                                // 2840
    var grainsHandle = grains.observe({                                                                                // 2841
      added: function (newGrain) {                                                                                     // 2842
        // Watch out: DevApp grains can lack a packageId.                                                              // 2843
        if (newGrain.packageId) {                                                                                      // 2844
          refPackage(newGrain.packageId);                                                                              // 2845
        }                                                                                                              // 2846
      },                                                                                                               // 2847
      changed: function (newGrain, oldGrain) {                                                                         // 2849
        // Watch out: DevApp grains can lack a packageId.                                                              // 2850
        if (newGrain.packageId) {                                                                                      // 2851
          refPackage(newGrain.packageId);                                                                              // 2852
        }                                                                                                              // 2853
      }                                                                                                                // 2854
    });                                                                                                                // 2841
    this.onStop(function () {                                                                                          // 2857
      actionsHandle.stop();                                                                                            // 2858
      grainsHandle.stop();                                                                                             // 2859
    });                                                                                                                // 2860
    this.ready();                                                                                                      // 2862
  });                                                                                                                  // 2863
}                                                                                                                      // 2864
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2866
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2867
    check(identityId, String);                                                                                         // 2868
    this.removeApiTokens({                                                                                             // 2870
      "owner.user.identityId": identityId                                                                              // 2870
    });                                                                                                                // 2870
    this.collections.contacts.remove({                                                                                 // 2871
      identityId: identityId                                                                                           // 2871
    });                                                                                                                // 2871
    Meteor.users.remove({                                                                                              // 2872
      _id: identityId                                                                                                  // 2872
    });                                                                                                                // 2872
  };                                                                                                                   // 2873
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2875
    check(userId, String);                                                                                             // 2876
                                                                                                                       //
    var _this = this;                                                                                                  // 2878
                                                                                                                       //
    var user = Meteor.users.findOne({                                                                                  // 2879
      _id: userId                                                                                                      // 2879
    });                                                                                                                // 2879
    this.deleteGrains({                                                                                                // 2880
      userId: userId                                                                                                   // 2880
    }, backend, "grain");                                                                                              // 2880
    this.collections.userActions.remove({                                                                              // 2881
      userId: userId                                                                                                   // 2881
    });                                                                                                                // 2881
    this.collections.notifications.remove({                                                                            // 2882
      userId: userId                                                                                                   // 2882
    });                                                                                                                // 2882
    user.loginIdentities.forEach(function (identity) {                                                                 // 2883
      if (Meteor.users.find({                                                                                          // 2884
        $or: [{                                                                                                        // 2884
          "loginIdentities.id": identity.id                                                                            // 2885
        }, {                                                                                                           // 2885
          "nonloginIdentities.id": identity.id                                                                         // 2886
        }]                                                                                                             // 2886
      }).count() === 1) {                                                                                              // 2884
        // If this is the only account with the identity, then delete it                                               // 2888
        _this.deleteIdentity(identity.id);                                                                             // 2889
      }                                                                                                                // 2890
    });                                                                                                                // 2891
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2892
      if (Meteor.users.find({                                                                                          // 2893
        $or: [{                                                                                                        // 2893
          "loginIdentities.id": identity.id                                                                            // 2894
        }, {                                                                                                           // 2894
          "nonloginIdentities.id": identity.id                                                                         // 2895
        }]                                                                                                             // 2895
      }).count() === 1) {                                                                                              // 2893
        // If this is the only account with the identity, then delete it                                               // 2897
        _this.deleteIdentity(identity.id);                                                                             // 2898
      }                                                                                                                // 2899
    });                                                                                                                // 2900
    this.collections.contacts.remove({                                                                                 // 2901
      ownerId: userId                                                                                                  // 2901
    });                                                                                                                // 2901
    backend.deleteUser(userId);                                                                                        // 2902
    Meteor.users.remove({                                                                                              // 2903
      _id: userId                                                                                                      // 2903
    });                                                                                                                // 2903
  };                                                                                                                   // 2904
}                                                                                                                      // 2905
                                                                                                                       //
Meteor.methods({                                                                                                       // 2907
  addUserActions: function (packageId) {                                                                               // 2908
    check(packageId, String);                                                                                          // 2909
                                                                                                                       //
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2910
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2911
    }                                                                                                                  // 2912
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2914
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      // 2915
      //   a proper DB object to use.                                                                                  // 2916
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2917
    } else {                                                                                                           // 2918
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2919
    }                                                                                                                  // 2920
  },                                                                                                                   // 2921
  removeUserAction: function (actionId) {                                                                              // 2923
    check(actionId, String);                                                                                           // 2924
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2925
      UserActions.remove({                                                                                             // 2926
        _id: actionId                                                                                                  // 2926
      });                                                                                                              // 2926
    } else {                                                                                                           // 2927
      if (this.userId) {                                                                                               // 2928
        var result = this.connection.sandstormDb.collections.userActions.findAndModify({                               // 2929
          query: {                                                                                                     // 2930
            _id: actionId,                                                                                             // 2930
            userId: this.userId                                                                                        // 2930
          },                                                                                                           // 2930
          remove: true                                                                                                 // 2931
        });                                                                                                            // 2929
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2934
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2935
        }                                                                                                              // 2936
                                                                                                                       //
        var action = result.value;                                                                                     // 2938
                                                                                                                       //
        if (action) {                                                                                                  // 2939
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2940
        }                                                                                                              // 2941
      }                                                                                                                // 2942
    }                                                                                                                  // 2943
  }                                                                                                                    // 2944
});                                                                                                                    // 2907
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       // 22
    // has a given identity linked. Automatically stops the subscription if the user loses the                         // 23
    // identity. Returns a boolean indicating whether the user initially has the identity.                             // 24
    var userId = publishHandler.userId;                                                                                // 26
                                                                                                                       //
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var hasIdentityCursor = Meteor.users.find({                                                                      // 30
        $or: [{                                                                                                        // 31
          _id: userId,                                                                                                 // 33
          "loginIdentities.id": identityId                                                                             // 34
        }, {                                                                                                           // 32
          _id: userId,                                                                                                 // 37
          "nonloginIdentities.id": identityId                                                                          // 38
        }]                                                                                                             // 36
      });                                                                                                              // 30
                                                                                                                       //
      if (hasIdentityCursor.count() == 0) {                                                                            // 42
        publishHandler.stop();                                                                                         // 43
        return false;                                                                                                  // 44
      }                                                                                                                // 45
                                                                                                                       //
      var handle = hasIdentityCursor.observe({                                                                         // 47
        removed: function () {                                                                                         // 47
          publishHandler.stop();                                                                                       // 47
        }                                                                                                              // 47
      });                                                                                                              // 47
      publishHandler.onStop(function () {                                                                              // 49
        handle.stop();                                                                                                 // 49
      });                                                                                                              // 49
      return true;                                                                                                     // 51
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
    return Meteor.users.find({                                                                                         // 59
      _id: identityId                                                                                                  // 59
    }, {                                                                                                               // 59
      fields: {                                                                                                        // 60
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
        "services.dev.name": 1,                                                                                        // 66
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
        "services.email.email": 1,                                                                                     // 81
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                // 95
    if (!this.userId) return [];                                                                                       // 97
    return Meteor.users.find({                                                                                         // 99
      _id: this.userId                                                                                                 // 100
    }, {                                                                                                               // 100
      fields: {                                                                                                        // 101
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      }                                                                                                                // 101
    });                                                                                                                // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function (id) {                                                                                      // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
                                                                                                                       //
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  var identiconCache = {};                                                                                             // 119
                                                                                                                       //
  makeIdenticon = function (id) {                                                                                      // 121
    // Given a cryptographic hash as input, generate an identicon. We always use the user's                            // 122
    // identity ID as the input hash (the same thing passed to apps as the user ID).                                   // 123
    // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                         // 125
    // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                     // 126
    // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                        // 127
    // anyway to be safe.                                                                                              // 128
    var hash = id.slice(0, 32);                                                                                        // 129
                                                                                                                       //
    if (hash in identiconCache) {                                                                                      // 131
      return identiconCache[hash];                                                                                     // 132
    } // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     // 133
                                                                                                                       //
                                                                                                                       //
    var data = new Identicon(hash, 512).toString();                                                                    // 136
    var result = "data:image/svg+xml," + encodeURIComponent(data);                                                     // 137
    identiconCache[hash] = result;                                                                                     // 138
    return result;                                                                                                     // 139
  };                                                                                                                   // 140
                                                                                                                       //
  httpProtocol = window.location.protocol;                                                                             // 142
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = {                                                                                                        // 145
  male: "male",                                                                                                        // 145
  female: "female",                                                                                                    // 145
  neutral: "neutral",                                                                                                  // 145
  robot: "robot"                                                                                                       // 145
};                                                                                                                     // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            // 156
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              // 161
  if (!email) return undefined; // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters
  // on the same account.                                                                                              // 166
                                                                                                                       //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
  var domain = (parts[1] || "").split(".");                                                                            // 170
                                                                                                                       //
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   // 172
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            // 180
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
                                                                                                                       //
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({                                                                                   // 213
      _id: "ldapNameField"                                                                                             // 213
    });                                                                                                                // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
                                                                                                                       //
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              // 256
    return [{                                                                                                          // 257
      email: identity.services.google.email,                                                                           // 257
      primary: true                                                                                                    // 257
    }];                                                                                                                // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{                                                                                                          // 259
      email: identity.services.email.email,                                                                            // 259
      primary: true                                                                                                    // 259
    }];                                                                                                                // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        // 266
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
                                                                                                                       //
    if (email) {                                                                                                       // 268
      return [{                                                                                                        // 269
        email: email,                                                                                                  // 269
        primary: true                                                                                                  // 269
      }];                                                                                                              // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{                                                                                                          // 272
      email: identity.services.saml.email,                                                                             // 272
      primary: true                                                                                                    // 272
    }];                                                                                                                // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        // 279
  // addresses.                                                                                                        // 280
  check(email, String); // For LDAP, the field containing the e-mail address is configurable...                        // 282
                                                                                                                       //
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
  return Meteor.users.find({                                                                                           // 288
    $or: [{                                                                                                            // 288
      "services.google.email": email                                                                                   // 289
    }, {                                                                                                               // 289
      "services.email.email": email                                                                                    // 290
    }, {                                                                                                               // 290
      "services.github.emails.email": email                                                                            // 291
    }, ldapQuery, {                                                                                                    // 291
      "services.saml.email": email                                                                                     // 293
    }]                                                                                                                 // 293
  }).fetch().filter(function (identity) {                                                                              // 288
    // Verify that the email is verified, since our query doesn't technically do that.                                 // 295
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), {                                                    // 296
      email: email                                                                                                     // 296
    });                                                                                                                // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
                                                                                                                       //
  return Meteor.users.find({                                                                                           // 302
    $or: [{                                                                                                            // 302
      "loginIdentities.id": {                                                                                          // 303
        $in: identityIds                                                                                               // 303
      }                                                                                                                // 303
    }, {                                                                                                               // 303
      "nonloginIdentities.id": {                                                                                       // 304
        $in: identityIds                                                                                               // 304
      }                                                                                                                // 304
    }]                                                                                                                 // 304
  }).fetch();                                                                                                          // 302
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   // 315
  // account. Always returns the most recently added login identity first.                                             // 316
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   // 325
  // Each entry in the array is an object of the form:                                                                 // 326
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    // 327
  //                                                                                                                   // 328
  // At most one entry in the result has `primary = true`.                                                             // 329
  //                                                                                                                   // 330
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         // 331
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         // 332
  //   on SandstormDb.                                                                                                 // 333
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({                                                                              // 340
      _id: id                                                                                                          // 340
    });                                                                                                                // 340
                                                                                                                       //
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
  var result = [];                                                                                                     // 354
                                                                                                                       //
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({                                                                                                      // 356
      email: email,                                                                                                    // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail                                                                             // 358
    });                                                                                                                // 356
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({                                                                                                    // 362
        email: email,                                                                                                  // 362
        verified: false                                                                                                // 362
      });                                                                                                              // 362
    }                                                                                                                  // 362
  }); // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                           // 363
                                                                                                                       //
                                                                                                                       //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function () {                                                                       // 373
  function addContact(ownerId, identityId) {                                                                           // 373
    check(ownerId, String);                                                                                            // 374
    check(identityId, String);                                                                                         // 375
    var profile = this.getIdentity(identityId).profile;                                                                // 376
    this.collections.contacts.upsert({                                                                                 // 377
      ownerId: ownerId,                                                                                                // 377
      identityId: identityId                                                                                           // 377
    }, {                                                                                                               // 377
      ownerId: ownerId,                                                                                                // 378
      petname: profile && profile.name,                                                                                // 379
      created: new Date(),                                                                                             // 380
      identityId: identityId                                                                                           // 381
    });                                                                                                                // 377
  }                                                                                                                    // 383
                                                                                                                       //
  return addContact;                                                                                                   // 373
}();                                                                                                                   // 373
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
